import{HttpResponse}from"@smithy/protocol-http";import{buildQueryString}from"@smithy/querystring-builder";import{Agent as hAgent,request as hRequest}from"http";import{Agent as hsAgent,request as hsRequest}from"https";import{NODEJS_TIMEOUT_ERROR_CODES}from"./constants";import{getTransformedHeaders}from"./get-transformed-headers";import{setConnectionTimeout}from"./set-connection-timeout";import{setSocketKeepAlive}from"./set-socket-keep-alive";import{setSocketTimeout}from"./set-socket-timeout";import{writeRequestBody}from"./write-request-body";export const DEFAULT_REQUEST_TIMEOUT=0;export class NodeHttpHandler{static create(e){return"function"==typeof e?.handle?e:new NodeHttpHandler(e)}static checkSocketUsage(e,t){const{sockets:o,requests:s,maxSockets:n}=e;if("number"!=typeof n||n===1/0)return t;if(Date.now()-15e3<t)return t;if(o&&s)for(const e in o){const t=o[e]?.length??0,i=s[e]?.length??0;if(t>=n&&i>=2*n)return console.warn("@smithy/node-http-handler:WARN",`socket usage at capacity=${t} and ${i} additional requests are enqueued.`,"See https://docs.aws.amazon.com/sdk-for-javascript/v3/developer-guide/node-configuring-maxsockets.html","or increase socketAcquisitionWarningTimeout=(millis) in the NodeHttpHandler config."),Date.now()}return t}constructor(e){this.socketWarningTimestamp=0,this.metadata={handlerProtocol:"http/1.1"},this.configProvider=new Promise(((t,o)=>{"function"==typeof e?e().then((e=>{t(this.resolveDefaultConfig(e))})).catch(o):t(this.resolveDefaultConfig(e))}))}resolveDefaultConfig(e){const{requestTimeout:t,connectionTimeout:o,socketTimeout:s,httpAgent:n,httpsAgent:i}=e||{};return{connectionTimeout:o,requestTimeout:t??s,httpAgent:n instanceof hAgent||"function"==typeof n?.destroy?n:new hAgent({keepAlive:!0,maxSockets:50,...n}),httpsAgent:i instanceof hsAgent||"function"==typeof i?.destroy?i:new hsAgent({keepAlive:!0,maxSockets:50,...i})}}destroy(){this.config?.httpAgent?.destroy(),this.config?.httpsAgent?.destroy()}async handle(e,{abortSignal:t}={}){let o;return this.config||(this.config=await this.configProvider),new Promise(((s,n)=>{let i;const r=async e=>{await i,n(e)};if(!this.config)throw new Error("Node HTTP request handler config is not resolved");if(t?.aborted){const e=new Error("Request aborted");return e.name="AbortError",void r(e)}const a="https:"===e.protocol,c=a?this.config.httpsAgent:this.config.httpAgent;o=setTimeout((()=>{this.socketWarningTimestamp=NodeHttpHandler.checkSocketUsage(c,this.socketWarningTimestamp)}),this.config.socketAcquisitionWarningTimeout??(this.config.requestTimeout??2e3)+(this.config.connectionTimeout??1e3));const h=buildQueryString(e.query||{});let u;if(null!=e.username||null!=e.password){u=`${e.username??""}:${e.password??""}`}let m=e.path;h&&(m+=`?${h}`),e.fragment&&(m+=`#${e.fragment}`);const p={headers:e.headers,host:e.hostname,method:e.method,path:m,port:e.port,agent:c,auth:u},g=(a?hsRequest:hRequest)(p,(e=>{(async e=>{await i,clearTimeout(o),s(e)})({response:new HttpResponse({statusCode:e.statusCode||-1,reason:e.statusMessage,headers:getTransformedHeaders(e.headers),body:e})})}));g.on("error",(e=>{NODEJS_TIMEOUT_ERROR_CODES.includes(e.code)?r(Object.assign(e,{name:"TimeoutError"})):r(e)})),setConnectionTimeout(g,r,this.config.connectionTimeout),setSocketTimeout(g,r,this.config.requestTimeout),t&&(t.onabort=()=>{g.abort();const e=new Error("Request aborted");e.name="AbortError",r(e)});const d=p.agent;"object"==typeof d&&"keepAlive"in d&&setSocketKeepAlive(g,{keepAlive:d.keepAlive,keepAliveMsecs:d.keepAliveMsecs}),i=writeRequestBody(g,e,this.config.requestTimeout).catch(n)}))}updateHttpClientConfig(e,t){this.config=void 0,this.configProvider=this.configProvider.then((o=>({...o,[e]:t})))}httpHandlerConfigs(){return this.config??{}}}