import{ServiceClient}from"@azure/core-client";import{isNode}from"@azure/core-util";import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{AbortController}from"@azure/abort-controller";import{AuthenticationError,AuthenticationErrorName}from"../errors";import{getIdentityTokenEndpointSuffix}from"../util/identityTokenEndpoint";import{DefaultAuthorityHost,SDK_VERSION}from"../constants";import{tracingClient}from"../util/tracing";import{logger}from"../util/logging";import{parseExpirationTimestamp}from"../credentials/managedIdentityCredential/utils";const noCorrelationId="noCorrelationId";export function getIdentityClientAuthorityHost(t){let e=null==t?void 0:t.authorityHost;return isNode&&(e=null!=e?e:process.env.AZURE_AUTHORITY_HOST),null!=e?e:DefaultAuthorityHost}export class IdentityClient extends ServiceClient{constructor(t){var e,r;const o=`azsdk-js-identity/${SDK_VERSION}`,n=(null===(e=null==t?void 0:t.userAgentOptions)||void 0===e?void 0:e.userAgentPrefix)?`${t.userAgentOptions.userAgentPrefix} ${o}`:`${o}`,i=getIdentityClientAuthorityHost(t);if(!i.startsWith("https:"))throw new Error("The authorityHost address must use the 'https' protocol.");super(Object.assign(Object.assign({requestContentType:"application/json; charset=utf-8",retryOptions:{maxRetries:3}},t),{userAgentOptions:{userAgentPrefix:n},baseUri:i})),this.authorityHost=i,this.abortControllers=new Map,this.allowLoggingAccountIdentifiers=null===(r=null==t?void 0:t.loggingOptions)||void 0===r?void 0:r.allowLoggingAccountIdentifiers,this.tokenCredentialOptions=Object.assign({},t)}async sendTokenRequest(t){logger.info(`IdentityClient: sending token request to [${t.url}]`);const e=await this.sendRequest(t);if(!e.bodyAsText||200!==e.status&&201!==e.status){const t=new AuthenticationError(e.status,e.bodyAsText);throw logger.warning(`IdentityClient: authentication error. HTTP status: ${e.status}, ${t.errorResponse.errorDescription}`),t}{const r=JSON.parse(e.bodyAsText);if(!r.access_token)return null;this.logIdentifiers(e);const o={accessToken:{token:r.access_token,expiresOnTimestamp:parseExpirationTimestamp(r)},refreshToken:r.refresh_token};return logger.info(`IdentityClient: [${t.url}] token acquired, expires on ${o.accessToken.expiresOnTimestamp}`),o}}async refreshAccessToken(t,e,r,o,n,i={}){if(void 0===o)return null;logger.info(`IdentityClient: refreshing access token with client ID: ${e}, scopes: ${r} started`);const s={grant_type:"refresh_token",client_id:e,refresh_token:o,scope:r};void 0!==n&&(s.client_secret=n);const a=new URLSearchParams(s);return tracingClient.withSpan("IdentityClient.refreshAccessToken",i,(async r=>{try{const o=getIdentityTokenEndpointSuffix(t),n=createPipelineRequest({url:`${this.authorityHost}/${t}/${o}`,method:"POST",body:a.toString(),abortSignal:i.abortSignal,headers:createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),tracingOptions:r.tracingOptions}),s=await this.sendTokenRequest(n);return logger.info(`IdentityClient: refreshed token for client ID: ${e}`),s}catch(t){if(t.name===AuthenticationErrorName&&"interaction_required"===t.errorResponse.error)return logger.info(`IdentityClient: interaction required for client ID: ${e}`),null;throw logger.warning(`IdentityClient: failed refreshing token for client ID: ${e}: ${t}`),t}}))}generateAbortSignal(t){const e=new AbortController,r=this.abortControllers.get(t)||[];r.push(e),this.abortControllers.set(t,r);const o=e.signal.onabort;return e.signal.onabort=(...e)=>{this.abortControllers.set(t,void 0),o&&o(...e)},e.signal}abortRequests(t){const e=t||noCorrelationId,r=[...this.abortControllers.get(e)||[],...this.abortControllers.get(noCorrelationId)||[]];if(r.length){for(const t of r)t.abort();this.abortControllers.set(e,void 0)}}getCorrelationId(t){var e;const r=null===(e=null==t?void 0:t.body)||void 0===e?void 0:e.split("&").map((t=>t.split("="))).find((([t])=>"client-request-id"===t));return r&&r.length&&r[1]||noCorrelationId}async sendGetRequestAsync(t,e){const r=createPipelineRequest({url:t,method:"GET",body:null==e?void 0:e.body,headers:createHttpHeaders(null==e?void 0:e.headers),abortSignal:this.generateAbortSignal(noCorrelationId)}),o=await this.sendRequest(r);return this.logIdentifiers(o),{body:o.bodyAsText?JSON.parse(o.bodyAsText):void 0,headers:o.headers.toJSON(),status:o.status}}async sendPostRequestAsync(t,e){const r=createPipelineRequest({url:t,method:"POST",body:null==e?void 0:e.body,headers:createHttpHeaders(null==e?void 0:e.headers),abortSignal:this.generateAbortSignal(this.getCorrelationId(e))}),o=await this.sendRequest(r);return this.logIdentifiers(o),{body:o.bodyAsText?JSON.parse(o.bodyAsText):void 0,headers:o.headers.toJSON(),status:o.status}}getTokenCredentialOptions(){return this.tokenCredentialOptions}logIdentifiers(t){if(!this.allowLoggingAccountIdentifiers||!t.bodyAsText)return;try{const e=(t.parsedBody||JSON.parse(t.bodyAsText)).access_token;if(!e)return;const r=e.split(".")[1],{appid:o,upn:n,tid:i,oid:s}=JSON.parse(Buffer.from(r,"base64").toString("utf8"));logger.info(`[Authenticated account] Client ID: ${o}. Tenant ID: ${i}. User Principal Name: ${n||"No User Principal Name available"}. Object ID (user): ${s}`)}catch(t){logger.warning("allowLoggingAccountIdentifiers was set, but we couldn't log the account information. Error:",t.message)}}}