import*as msalNode from"@azure/msal-node";import{getLogLevel}from"@azure/logger";import{MsalBaseUtilities,defaultLoggerCallback,getAuthority,getKnownAuthorities,msalToPublic,publicToMsal,getMSALLogLevel}from"../utils";import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds,resolveTenantId}from"../../util/tenantIdUtils";import{AuthenticationRequiredError}from"../../errors";import{CACHE_CAE_SUFFIX,CACHE_NON_CAE_SUFFIX,DeveloperSignOnClientId}from"../../constants";import{IdentityClient}from"../../client/identityClient";import{RegionalAuthority}from"../../regionalAuthority";let persistenceProvider;export const msalNodeFlowCacheControl={setPersistence(e){persistenceProvider=e}};export class MsalNode extends MsalBaseUtilities{constructor(e){var t,i,n,o;if(super(e),this.app={},this.caeApp={},this.requiresConfidential=!1,this.msalConfig=this.defaultNodeMsalConfig(e),this.tenantId=resolveTenantId(e.logger,e.tenantId,e.clientId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null===(t=null==e?void 0:e.tokenCredentialOptions)||void 0===t?void 0:t.additionallyAllowedTenants),this.clientId=this.msalConfig.auth.clientId,(null==e?void 0:e.getAssertion)&&(this.getAssertion=e.getAssertion),void 0!==persistenceProvider&&(null===(i=e.tokenCachePersistenceOptions)||void 0===i?void 0:i.enabled)){const t=Object.assign({name:`${e.tokenCachePersistenceOptions.name}.${CACHE_NON_CAE_SUFFIX}`},e.tokenCachePersistenceOptions),i=Object.assign({name:`${e.tokenCachePersistenceOptions.name}.${CACHE_CAE_SUFFIX}`},e.tokenCachePersistenceOptions);this.createCachePlugin=()=>persistenceProvider(t),this.createCachePluginCae=()=>persistenceProvider(i)}else if(null===(n=e.tokenCachePersistenceOptions)||void 0===n?void 0:n.enabled)throw new Error(["Persistent token caching was requested, but no persistence provider was configured.","You must install the identity-cache-persistence plugin package (`npm install --save @azure/identity-cache-persistence`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(cachePersistencePlugin)` before using `tokenCachePersistenceOptions`."].join(" "));this.azureRegion=null!==(o=e.regionalAuthority)&&void 0!==o?o:process.env.AZURE_REGIONAL_AUTHORITY_NAME,this.azureRegion===RegionalAuthority.AutoDiscoverRegion&&(this.azureRegion="AUTO_DISCOVER")}defaultNodeMsalConfig(e){var t;const i=e.clientId||DeveloperSignOnClientId,n=resolveTenantId(e.logger,e.tenantId,e.clientId);this.authorityHost=e.authorityHost||process.env.AZURE_AUTHORITY_HOST;const o=getAuthority(n,this.authorityHost);this.identityClient=new IdentityClient(Object.assign(Object.assign({},e.tokenCredentialOptions),{authorityHost:o,loggingOptions:e.loggingOptions}));return{auth:{clientId:i,authority:o,knownAuthorities:getKnownAuthorities(n,o,e.disableInstanceDiscovery),clientCapabilities:[]},system:{networkClient:this.identityClient,loggerOptions:{loggerCallback:defaultLoggerCallback(e.logger),logLevel:getMSALLogLevel(getLogLevel()),piiLoggingEnabled:null===(t=e.loggingOptions)||void 0===t?void 0:t.enableUnsafeSupportLogging}}}}getApp(e,t){const i=t?this.caeApp:this.app;return"publicFirst"===e?i.public||i.confidential:"confidentialFirst"===e?i.confidential||i.public:"confidential"===e?i.confidential:i.public}async init(e){(null==e?void 0:e.abortSignal)&&e.abortSignal.addEventListener("abort",(()=>{this.identityClient.abortRequests(e.correlationId)}));const t=(null==e?void 0:e.enableCae)?this.caeApp:this.app;if((null==e?void 0:e.enableCae)&&(this.msalConfig.auth.clientCapabilities=["cp1"]),!t.public&&!t.confidential)if((null==e?void 0:e.enableCae)&&void 0!==this.createCachePluginCae&&(this.msalConfig.cache={cachePlugin:await this.createCachePluginCae()}),void 0!==this.createCachePlugin&&(this.msalConfig.cache={cachePlugin:await this.createCachePlugin()}),(null==e?void 0:e.enableCae)?this.caeApp.public=new msalNode.PublicClientApplication(this.msalConfig):this.app.public=new msalNode.PublicClientApplication(this.msalConfig),this.getAssertion&&(this.msalConfig.auth.clientAssertion=await this.getAssertion()),this.msalConfig.auth.clientSecret||this.msalConfig.auth.clientAssertion||this.msalConfig.auth.clientCertificate)(null==e?void 0:e.enableCae)?this.caeApp.confidential=new msalNode.ConfidentialClientApplication(this.msalConfig):this.app.confidential=new msalNode.ConfidentialClientApplication(this.msalConfig);else if(this.requiresConfidential)throw new Error("Unable to generate the MSAL confidential client. Missing either the client's secret, certificate or assertion.")}withCancellation(e,t,i){return new Promise(((n,o)=>{e.then((e=>n(e))).catch(o),t&&t.addEventListener("abort",(()=>{null==i||i()}))}))}async getActiveAccount(e=!1){if(this.account)return this.account;const t=this.getApp("confidentialFirst",e).getTokenCache(),i=await(null==t?void 0:t.getAllAccounts());if(i){if(1===i.length)return this.account=msalToPublic(this.clientId,i[0]),this.account;this.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.')}}async getTokenSilent(e,t){var i,n,o;if(await this.getActiveAccount(null==t?void 0:t.enableCae),!this.account)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Silent authentication failed. We couldn't retrieve an active account from the cache."});const a={account:publicToMsal(this.account),correlationId:null==t?void 0:t.correlationId,scopes:e,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims};try{this.logger.info("Attempting to acquire token silently"),await(null===(i=this.getApp("publicFirst",null==t?void 0:t.enableCae))||void 0===i?void 0:i.getTokenCache().getAllAccounts());const s=null!==(o=await(null===(n=this.getApp("confidential",null==t?void 0:t.enableCae))||void 0===n?void 0:n.acquireTokenSilent(a)))&&void 0!==o?o:await this.getApp("public",null==t?void 0:t.enableCae).acquireTokenSilent(a);return this.handleResult(e,this.clientId,s||void 0)}catch(i){throw this.handleError(e,i,t)}}async getToken(e,t={}){const i=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds)||this.tenantId;t.authority=getAuthority(i,this.authorityHost),t.correlationId=(null==t?void 0:t.correlationId)||this.generateUuid(),await this.init(t);try{const i=t.claims;return i&&(this.cachedClaims=i),this.cachedClaims&&!i&&(t.claims=this.cachedClaims),await this.getTokenSilent(e,t)}catch(i){if("AuthenticationRequiredError"!==i.name)throw i;if(null==t?void 0:t.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info("Silent authentication failed, falling back to interactive method."),this.doGetToken(e,t)}}}