"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var msalCommon=require("@azure/msal-node"),logger$o=require("@azure/logger"),abortController=require("@azure/abort-controller"),coreUtil=require("@azure/core-util"),coreClient=require("@azure/core-client"),coreRestPipeline=require("@azure/core-rest-pipeline"),coreTracing=require("@azure/core-tracing"),fs=require("fs"),os=require("os"),path=require("path"),promises=require("fs/promises"),https=require("https"),child_process=require("child_process"),crypto=require("crypto"),util=require("util"),http=require("http"),open=require("open"),stoppable=require("stoppable");function _interopDefaultLegacy(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}function _interopNamespace(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(n){if("default"!==n){var i=Object.getOwnPropertyDescriptor(e,n);Object.defineProperty(t,n,i.get?i:{enumerable:!0,get:function(){return e[n]}})}})),t.default=e,Object.freeze(t)}var msalCommon__namespace=_interopNamespace(msalCommon),fs__default=_interopDefaultLegacy(fs),os__default=_interopDefaultLegacy(os),path__default=_interopDefaultLegacy(path),https__default=_interopDefaultLegacy(https),child_process__default=_interopDefaultLegacy(child_process),child_process__namespace=_interopNamespace(child_process),http__default=_interopDefaultLegacy(http),open__default=_interopDefaultLegacy(open),stoppable__default=_interopDefaultLegacy(stoppable);function isErrorResponse(e){return e&&"string"==typeof e.error&&"string"==typeof e.error_description}const CredentialUnavailableErrorName="CredentialUnavailableError";class CredentialUnavailableError extends Error{constructor(e){super(e),this.name="CredentialUnavailableError"}}const AuthenticationErrorName="AuthenticationError";class AuthenticationError extends Error{constructor(e,t){let n={error:"unknown",errorDescription:"An unknown error occurred and no additional details are available."};if(isErrorResponse(t))n=convertOAuthErrorResponseToErrorResponse(t);else if("string"==typeof t)try{n=convertOAuthErrorResponseToErrorResponse(JSON.parse(t))}catch(i){n=400===e?{error:"authority_not_found",errorDescription:"The specified authority URL was not found."}:{error:"unknown_error",errorDescription:`An unknown error has occurred. Response body:\n\n${t}`}}else n={error:"unknown_error",errorDescription:"An unknown error occurred and no additional details are available."};super(`${n.error} Status code: ${e}\nMore details:\n${n.errorDescription}`),this.statusCode=e,this.errorResponse=n,this.name="AuthenticationError"}}const AggregateAuthenticationErrorName="AggregateAuthenticationError";class AggregateAuthenticationError extends Error{constructor(e,t){super(`${t}\n${e.join("\n")}`),this.errors=e,this.name="AggregateAuthenticationError"}}function convertOAuthErrorResponseToErrorResponse(e){return{error:e.error,errorDescription:e.error_description,correlationId:e.correlation_id,errorCodes:e.error_codes,timestamp:e.timestamp,traceId:e.trace_id}}class AuthenticationRequiredError extends Error{constructor(e){super(e.message),this.scopes=e.scopes,this.getTokenOptions=e.getTokenOptions,this.name="AuthenticationRequiredError"}}const logger$n=logger$o.createClientLogger("identity");function processEnvVars(e){return e.reduce(((e,t)=>(process.env[t]?e.assigned.push(t):e.missing.push(t),e)),{missing:[],assigned:[]})}function formatSuccess(e){return`SUCCESS. Scopes: ${Array.isArray(e)?e.join(", "):e}.`}function formatError(e,t){let n="ERROR.";return(null==e?void 0:e.length)&&(n+=` Scopes: ${Array.isArray(e)?e.join(", "):e}.`),`${n} Error message: ${"string"==typeof t?t:t.message}.`}function credentialLoggerInstance(e,t,n=logger$n){const i=t?`${t.fullTitle} ${e}`:e;return{title:e,fullTitle:i,info:function(e){n.info(`${i} =>`,e)},warning:function(e){n.warning(`${i} =>`,e)},verbose:function(e){n.verbose(`${i} =>`,e)}}}function credentialLogger(e,t=logger$n){const n=credentialLoggerInstance(e,void 0,t);return Object.assign(Object.assign({},n),{parent:t,getToken:credentialLoggerInstance("=> getToken()",n,t)})}const SDK_VERSION="3.4.2",DeveloperSignOnClientId="04b07795-8ddb-461a-bbee-02f9e1bf7b46",DefaultTenantId="common";exports.AzureAuthorityHosts=void 0,function(e){e.AzureChina="https://login.chinacloudapi.cn",e.AzureGermany="https://login.microsoftonline.de",e.AzureGovernment="https://login.microsoftonline.us",e.AzurePublicCloud="https://login.microsoftonline.com"}(exports.AzureAuthorityHosts||(exports.AzureAuthorityHosts={}));const DefaultAuthorityHost=exports.AzureAuthorityHosts.AzurePublicCloud,ALL_TENANTS=["*"],CACHE_CAE_SUFFIX=".cae",CACHE_NON_CAE_SUFFIX=".nocae",LatestAuthenticationRecordVersion="1.0";function ensureValidMsalToken(e,t,n,i){const r=n=>(t.getToken.info(n),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:i,message:n}));if(!n)throw r("No response");if(!n.expiresOn)throw r('Response had no "expiresOn" property.');if(!n.accessToken)throw r('Response had no "accessToken" property.')}function getAuthority(e,t){return t||(t=DefaultAuthorityHost),new RegExp(`${e}/?$`).test(t)?t:t.endsWith("/")?t+e:`${t}/${e}`}function getKnownAuthorities(e,t,n){return"adfs"===e&&t||n?[t]:[]}const defaultLoggerCallback=(e,t=(coreUtil.isNode?"Node":"Browser"))=>(n,i,r)=>{if(!r)switch(n){case msalCommon__namespace.LogLevel.Error:return void e.info(`MSAL ${t} V2 error: ${i}`);case msalCommon__namespace.LogLevel.Info:return void e.info(`MSAL ${t} V2 info message: ${i}`);case msalCommon__namespace.LogLevel.Verbose:return void e.info(`MSAL ${t} V2 verbose message: ${i}`);case msalCommon__namespace.LogLevel.Warning:return void e.info(`MSAL ${t} V2 warning: ${i}`)}};function getMSALLogLevel(e){switch(e){case"error":return msalCommon__namespace.LogLevel.Error;case"info":default:return msalCommon__namespace.LogLevel.Info;case"verbose":return msalCommon__namespace.LogLevel.Verbose;case"warning":return msalCommon__namespace.LogLevel.Warning}}class MsalBaseUtilities{constructor(e){this.logger=e.logger,this.account=e.authenticationRecord}generateUuid(){return coreUtil.randomUUID()}handleResult(e,t,n,i){return(null==n?void 0:n.account)&&(this.account=msalToPublic(t,n.account)),ensureValidMsalToken(e,this.logger,n,i),this.logger.getToken.info(formatSuccess(e)),{token:n.accessToken,expiresOnTimestamp:n.expiresOn.getTime()}}handleError(e,t,n){if("AuthError"===t.name||"ClientAuthError"===t.name||"BrowserAuthError"===t.name){const n=t;switch(n.errorCode){case"endpoints_resolution_error":return this.logger.info(formatError(e,t.message)),new CredentialUnavailableError(t.message);case"device_code_polling_cancelled":return new abortController.AbortError("The authentication has been aborted by the caller.");case"consent_required":case"interaction_required":case"login_required":this.logger.info(formatError(e,`Authentication returned errorCode ${n.errorCode}`));break;default:this.logger.info(formatError(e,`Failed to acquire token: ${t.message}`))}}return"ClientConfigurationError"===t.name||"BrowserConfigurationAuthError"===t.name||"AbortError"===t.name?t:new AuthenticationRequiredError({scopes:e,getTokenOptions:n,message:t.message})}}function publicToMsal(e){const[t]=e.authority.match(/([a-z]*\.[a-z]*\.[a-z]*)/)||[""];return Object.assign(Object.assign({},e),{localAccountId:e.homeAccountId,environment:t})}function msalToPublic(e,t){return{authority:getAuthority(t.tenantId,t.environment),homeAccountId:t.homeAccountId,tenantId:t.tenantId||"common",username:t.username,clientId:e,version:"1.0"}}function serializeAuthenticationRecord(e){return JSON.stringify(e)}function deserializeAuthenticationRecord(e){const t=JSON.parse(e);if(t.version&&"1.0"!==t.version)throw Error("Unsupported AuthenticationRecord version");return t}function createConfigurationErrorMessage(e){return`The current credential is not configured to acquire tokens for tenant ${e}. To enable acquiring tokens for this tenant add it to the AdditionallyAllowedTenants on the credential options, or add "*" to AdditionallyAllowedTenants to allow acquiring tokens for any tenant.`}function processMultiTenantRequest(e,t,n=[],i){var r;let o;if(o=process.env.AZURE_IDENTITY_DISABLE_MULTITENANTAUTH||"adfs"===e?e:null!==(r=null==t?void 0:t.tenantId)&&void 0!==r?r:e,e&&o!==e&&!n.includes("*")&&!n.some((e=>0===e.localeCompare(o)))){const t=createConfigurationErrorMessage(e);throw null==i||i.info(t),new CredentialUnavailableError(t)}return o}function checkTenantId(e,t){if(!t.match(/^[0-9a-zA-Z-.]+$/)){const t=new Error("Invalid tenant id provided. You can locate your tenant id by following the instructions listed here: https://learn.microsoft.com/partner-center/find-ids-and-domain-names.");throw e.info(formatError("",t)),t}}function resolveTenantId(e,t,n){return t?(checkTenantId(e,t),t):(n||(n=DeveloperSignOnClientId),n!==DeveloperSignOnClientId?"common":"organizations")}function resolveAdditionallyAllowedTenantIds(e){return e&&0!==e.length?e.includes("*")?ALL_TENANTS:e:[]}function getIdentityTokenEndpointSuffix(e){return"adfs"===e?"oauth2/token":"oauth2/v2.0/token"}const tracingClient=coreTracing.createTracingClient({namespace:"Microsoft.AAD",packageName:"@azure/identity",packageVersion:"3.4.2"}),DefaultScopeSuffix="/.default",imdsHost="http://169.254.169.254",imdsEndpointPath="/metadata/identity/oauth2/token",imdsApiVersion="2018-02-01",azureArcAPIVersion="2019-11-01",azureFabricVersion="2019-07-01-preview";function mapScopesToResource(e){let t="";if(Array.isArray(e)){if(1!==e.length)return;t=e[0]}else"string"==typeof e&&(t=e);return t.endsWith(DefaultScopeSuffix)?t.substr(0,t.lastIndexOf(DefaultScopeSuffix)):t}function parseExpirationTimestamp(e){if("number"==typeof e.expires_on)return 1e3*e.expires_on;if("string"==typeof e.expires_on){const t=+e.expires_on;if(!isNaN(t))return 1e3*t;const n=Date.parse(e.expires_on);if(!isNaN(n))return n}if("number"==typeof e.expires_in)return Date.now()+1e3*e.expires_in;throw new Error(`Failed to parse token expiration from body. expires_in="${e.expires_in}", expires_on="${e.expires_on}"`)}const noCorrelationId="noCorrelationId";function getIdentityClientAuthorityHost(e){let t=null==e?void 0:e.authorityHost;return coreUtil.isNode&&(t=null!=t?t:process.env.AZURE_AUTHORITY_HOST),null!=t?t:DefaultAuthorityHost}class IdentityClient extends coreClient.ServiceClient{constructor(e){var t,n;const i="azsdk-js-identity/3.4.2",r=(null===(t=null==e?void 0:e.userAgentOptions)||void 0===t?void 0:t.userAgentPrefix)?`${e.userAgentOptions.userAgentPrefix} ${i}`:`${i}`,o=getIdentityClientAuthorityHost(e);if(!o.startsWith("https:"))throw new Error("The authorityHost address must use the 'https' protocol.");super(Object.assign(Object.assign({requestContentType:"application/json; charset=utf-8",retryOptions:{maxRetries:3}},e),{userAgentOptions:{userAgentPrefix:r},baseUri:o})),this.authorityHost=o,this.abortControllers=new Map,this.allowLoggingAccountIdentifiers=null===(n=null==e?void 0:e.loggingOptions)||void 0===n?void 0:n.allowLoggingAccountIdentifiers,this.tokenCredentialOptions=Object.assign({},e)}async sendTokenRequest(e){logger$n.info(`IdentityClient: sending token request to [${e.url}]`);const t=await this.sendRequest(e);if(!t.bodyAsText||200!==t.status&&201!==t.status){const e=new AuthenticationError(t.status,t.bodyAsText);throw logger$n.warning(`IdentityClient: authentication error. HTTP status: ${t.status}, ${e.errorResponse.errorDescription}`),e}{const n=JSON.parse(t.bodyAsText);if(!n.access_token)return null;this.logIdentifiers(t);const i={accessToken:{token:n.access_token,expiresOnTimestamp:parseExpirationTimestamp(n)},refreshToken:n.refresh_token};return logger$n.info(`IdentityClient: [${e.url}] token acquired, expires on ${i.accessToken.expiresOnTimestamp}`),i}}async refreshAccessToken(e,t,n,i,r,o={}){if(void 0===i)return null;logger$n.info(`IdentityClient: refreshing access token with client ID: ${t}, scopes: ${n} started`);const a={grant_type:"refresh_token",client_id:t,refresh_token:i,scope:n};void 0!==r&&(a.client_secret=r);const s=new URLSearchParams(a);return tracingClient.withSpan("IdentityClient.refreshAccessToken",o,(async n=>{try{const i=getIdentityTokenEndpointSuffix(e),r=coreRestPipeline.createPipelineRequest({url:`${this.authorityHost}/${e}/${i}`,method:"POST",body:s.toString(),abortSignal:o.abortSignal,headers:coreRestPipeline.createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),tracingOptions:n.tracingOptions}),a=await this.sendTokenRequest(r);return logger$n.info(`IdentityClient: refreshed token for client ID: ${t}`),a}catch(e){if("AuthenticationError"===e.name&&"interaction_required"===e.errorResponse.error)return logger$n.info(`IdentityClient: interaction required for client ID: ${t}`),null;throw logger$n.warning(`IdentityClient: failed refreshing token for client ID: ${t}: ${e}`),e}}))}generateAbortSignal(e){const t=new abortController.AbortController,n=this.abortControllers.get(e)||[];n.push(t),this.abortControllers.set(e,n);const i=t.signal.onabort;return t.signal.onabort=(...t)=>{this.abortControllers.set(e,void 0),i&&i(...t)},t.signal}abortRequests(e){const t=e||noCorrelationId,n=[...this.abortControllers.get(t)||[],...this.abortControllers.get(noCorrelationId)||[]];if(n.length){for(const e of n)e.abort();this.abortControllers.set(t,void 0)}}getCorrelationId(e){var t;const n=null===(t=null==e?void 0:e.body)||void 0===t?void 0:t.split("&").map((e=>e.split("="))).find((([e])=>"client-request-id"===e));return n&&n.length&&n[1]||noCorrelationId}async sendGetRequestAsync(e,t){const n=coreRestPipeline.createPipelineRequest({url:e,method:"GET",body:null==t?void 0:t.body,headers:coreRestPipeline.createHttpHeaders(null==t?void 0:t.headers),abortSignal:this.generateAbortSignal(noCorrelationId)}),i=await this.sendRequest(n);return this.logIdentifiers(i),{body:i.bodyAsText?JSON.parse(i.bodyAsText):void 0,headers:i.headers.toJSON(),status:i.status}}async sendPostRequestAsync(e,t){const n=coreRestPipeline.createPipelineRequest({url:e,method:"POST",body:null==t?void 0:t.body,headers:coreRestPipeline.createHttpHeaders(null==t?void 0:t.headers),abortSignal:this.generateAbortSignal(this.getCorrelationId(t))}),i=await this.sendRequest(n);return this.logIdentifiers(i),{body:i.bodyAsText?JSON.parse(i.bodyAsText):void 0,headers:i.headers.toJSON(),status:i.status}}getTokenCredentialOptions(){return this.tokenCredentialOptions}logIdentifiers(e){if(!this.allowLoggingAccountIdentifiers||!e.bodyAsText)return;try{const t=(e.parsedBody||JSON.parse(e.bodyAsText)).access_token;if(!t)return;const n=t.split(".")[1],{appid:i,upn:r,tid:o,oid:a}=JSON.parse(Buffer.from(n,"base64").toString("utf8"));logger$n.info(`[Authenticated account] Client ID: ${i}. Tenant ID: ${o}. User Principal Name: ${r||"No User Principal Name available"}. Object ID (user): ${a}`)}catch(e){logger$n.warning("allowLoggingAccountIdentifiers was set, but we couldn't log the account information. Error:",e.message)}}}var RegionalAuthority;let persistenceProvider;!function(e){e.AutoDiscoverRegion="AutoDiscoverRegion",e.USWest="westus",e.USWest2="westus2",e.USCentral="centralus",e.USEast="eastus",e.USEast2="eastus2",e.USNorthCentral="northcentralus",e.USSouthCentral="southcentralus",e.USWestCentral="westcentralus",e.CanadaCentral="canadacentral",e.CanadaEast="canadaeast",e.BrazilSouth="brazilsouth",e.EuropeNorth="northeurope",e.EuropeWest="westeurope",e.UKSouth="uksouth",e.UKWest="ukwest",e.FranceCentral="francecentral",e.FranceSouth="francesouth",e.SwitzerlandNorth="switzerlandnorth",e.SwitzerlandWest="switzerlandwest",e.GermanyNorth="germanynorth",e.GermanyWestCentral="germanywestcentral",e.NorwayWest="norwaywest",e.NorwayEast="norwayeast",e.AsiaEast="eastasia",e.AsiaSouthEast="southeastasia",e.JapanEast="japaneast",e.JapanWest="japanwest",e.AustraliaEast="australiaeast",e.AustraliaSouthEast="australiasoutheast",e.AustraliaCentral="australiacentral",e.AustraliaCentral2="australiacentral2",e.IndiaCentral="centralindia",e.IndiaSouth="southindia",e.IndiaWest="westindia",e.KoreaSouth="koreasouth",e.KoreaCentral="koreacentral",e.UAECentral="uaecentral",e.UAENorth="uaenorth",e.SouthAfricaNorth="southafricanorth",e.SouthAfricaWest="southafricawest",e.ChinaNorth="chinanorth",e.ChinaEast="chinaeast",e.ChinaNorth2="chinanorth2",e.ChinaEast2="chinaeast2",e.GermanyCentral="germanycentral",e.GermanyNorthEast="germanynortheast",e.GovernmentUSVirginia="usgovvirginia",e.GovernmentUSIowa="usgoviowa",e.GovernmentUSArizona="usgovarizona",e.GovernmentUSTexas="usgovtexas",e.GovernmentUSDodEast="usdodeast",e.GovernmentUSDodCentral="usdodcentral"}(RegionalAuthority||(RegionalAuthority={}));const msalNodeFlowCacheControl={setPersistence(e){persistenceProvider=e}};class MsalNode extends MsalBaseUtilities{constructor(e){var t,n,i,r;if(super(e),this.app={},this.caeApp={},this.requiresConfidential=!1,this.msalConfig=this.defaultNodeMsalConfig(e),this.tenantId=resolveTenantId(e.logger,e.tenantId,e.clientId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null===(t=null==e?void 0:e.tokenCredentialOptions)||void 0===t?void 0:t.additionallyAllowedTenants),this.clientId=this.msalConfig.auth.clientId,(null==e?void 0:e.getAssertion)&&(this.getAssertion=e.getAssertion),void 0!==persistenceProvider&&(null===(n=e.tokenCachePersistenceOptions)||void 0===n?void 0:n.enabled)){const t=Object.assign({name:`${e.tokenCachePersistenceOptions.name}..nocae`},e.tokenCachePersistenceOptions),n=Object.assign({name:`${e.tokenCachePersistenceOptions.name}..cae`},e.tokenCachePersistenceOptions);this.createCachePlugin=()=>persistenceProvider(t),this.createCachePluginCae=()=>persistenceProvider(n)}else if(null===(i=e.tokenCachePersistenceOptions)||void 0===i?void 0:i.enabled)throw new Error(["Persistent token caching was requested, but no persistence provider was configured.","You must install the identity-cache-persistence plugin package (`npm install --save @azure/identity-cache-persistence`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(cachePersistencePlugin)` before using `tokenCachePersistenceOptions`."].join(" "));this.azureRegion=null!==(r=e.regionalAuthority)&&void 0!==r?r:process.env.AZURE_REGIONAL_AUTHORITY_NAME,this.azureRegion===RegionalAuthority.AutoDiscoverRegion&&(this.azureRegion="AUTO_DISCOVER")}defaultNodeMsalConfig(e){var t;const n=e.clientId||DeveloperSignOnClientId,i=resolveTenantId(e.logger,e.tenantId,e.clientId);this.authorityHost=e.authorityHost||process.env.AZURE_AUTHORITY_HOST;const r=getAuthority(i,this.authorityHost);this.identityClient=new IdentityClient(Object.assign(Object.assign({},e.tokenCredentialOptions),{authorityHost:r,loggingOptions:e.loggingOptions}));return{auth:{clientId:n,authority:r,knownAuthorities:getKnownAuthorities(i,r,e.disableInstanceDiscovery),clientCapabilities:[]},system:{networkClient:this.identityClient,loggerOptions:{loggerCallback:defaultLoggerCallback(e.logger),logLevel:getMSALLogLevel(logger$o.getLogLevel()),piiLoggingEnabled:null===(t=e.loggingOptions)||void 0===t?void 0:t.enableUnsafeSupportLogging}}}}getApp(e,t){const n=t?this.caeApp:this.app;return"publicFirst"===e?n.public||n.confidential:"confidentialFirst"===e?n.confidential||n.public:"confidential"===e?n.confidential:n.public}async init(e){(null==e?void 0:e.abortSignal)&&e.abortSignal.addEventListener("abort",(()=>{this.identityClient.abortRequests(e.correlationId)}));const t=(null==e?void 0:e.enableCae)?this.caeApp:this.app;if((null==e?void 0:e.enableCae)&&(this.msalConfig.auth.clientCapabilities=["cp1"]),!t.public&&!t.confidential)if((null==e?void 0:e.enableCae)&&void 0!==this.createCachePluginCae&&(this.msalConfig.cache={cachePlugin:await this.createCachePluginCae()}),void 0!==this.createCachePlugin&&(this.msalConfig.cache={cachePlugin:await this.createCachePlugin()}),(null==e?void 0:e.enableCae)?this.caeApp.public=new msalCommon__namespace.PublicClientApplication(this.msalConfig):this.app.public=new msalCommon__namespace.PublicClientApplication(this.msalConfig),this.getAssertion&&(this.msalConfig.auth.clientAssertion=await this.getAssertion()),this.msalConfig.auth.clientSecret||this.msalConfig.auth.clientAssertion||this.msalConfig.auth.clientCertificate)(null==e?void 0:e.enableCae)?this.caeApp.confidential=new msalCommon__namespace.ConfidentialClientApplication(this.msalConfig):this.app.confidential=new msalCommon__namespace.ConfidentialClientApplication(this.msalConfig);else if(this.requiresConfidential)throw new Error("Unable to generate the MSAL confidential client. Missing either the client's secret, certificate or assertion.")}withCancellation(e,t,n){return new Promise(((i,r)=>{e.then((e=>i(e))).catch(r),t&&t.addEventListener("abort",(()=>{null==n||n()}))}))}async getActiveAccount(e=!1){if(this.account)return this.account;const t=this.getApp("confidentialFirst",e).getTokenCache(),n=await(null==t?void 0:t.getAllAccounts());if(n){if(1===n.length)return this.account=msalToPublic(this.clientId,n[0]),this.account;this.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.')}}async getTokenSilent(e,t){var n,i,r;if(await this.getActiveAccount(null==t?void 0:t.enableCae),!this.account)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Silent authentication failed. We couldn't retrieve an active account from the cache."});const o={account:publicToMsal(this.account),correlationId:null==t?void 0:t.correlationId,scopes:e,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims};try{this.logger.info("Attempting to acquire token silently"),await(null===(n=this.getApp("publicFirst",null==t?void 0:t.enableCae))||void 0===n?void 0:n.getTokenCache().getAllAccounts());const a=null!==(r=await(null===(i=this.getApp("confidential",null==t?void 0:t.enableCae))||void 0===i?void 0:i.acquireTokenSilent(o)))&&void 0!==r?r:await this.getApp("public",null==t?void 0:t.enableCae).acquireTokenSilent(o);return this.handleResult(e,this.clientId,a||void 0)}catch(n){throw this.handleError(e,n,t)}}async getToken(e,t={}){const n=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds)||this.tenantId;t.authority=getAuthority(n,this.authorityHost),t.correlationId=(null==t?void 0:t.correlationId)||this.generateUuid(),await this.init(t);try{const n=t.claims;return n&&(this.cachedClaims=n),this.cachedClaims&&!n&&(t.claims=this.cachedClaims),await this.getTokenSilent(e,t)}catch(n){if("AuthenticationRequiredError"!==n.name)throw n;if(null==t?void 0:t.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info("Silent authentication failed, falling back to interactive method."),this.doGetToken(e,t)}}}const CommonTenantId="common",AzureAccountClientId="aebc6443-996d-45c2-90f0-388ff96faa56",logger$m=credentialLogger("VisualStudioCodeCredential");let findCredentials;const vsCodeCredentialControl={setVsCodeCredentialFinder(e){findCredentials=e}},unsupportedTenantIds={adfs:"The VisualStudioCodeCredential does not support authentication with ADFS tenants."};function checkUnsupportedTenant(e){const t=unsupportedTenantIds[e];if(t)throw new CredentialUnavailableError(t)}const mapVSCodeAuthorityHosts={AzureCloud:exports.AzureAuthorityHosts.AzurePublicCloud,AzureChina:exports.AzureAuthorityHosts.AzureChina,AzureGermanCloud:exports.AzureAuthorityHosts.AzureGermany,AzureUSGovernment:exports.AzureAuthorityHosts.AzureGovernment};function getPropertyFromVSCode(e){const t=["User","settings.json"],n=os__default.default.homedir();function i(...n){const i=path__default.default.join(...n,"Code",...t);return JSON.parse(fs__default.default.readFileSync(i,{encoding:"utf8"}))[e]}try{let e;switch(process.platform){case"win32":return e=process.env.APPDATA,e?i(e):void 0;case"darwin":return i(n,"Library","Application Support");case"linux":return i(n,".config");default:return}}catch(e){return void logger$m.info(`Failed to load the Visual Studio Code configuration file. Error: ${e.message}`)}}class VisualStudioCodeCredential{constructor(e){this.cloudName=getPropertyFromVSCode("azure.cloud")||"AzureCloud";const t=mapVSCodeAuthorityHosts[this.cloudName];this.identityClient=new IdentityClient(Object.assign({authorityHost:t},e)),e&&e.tenantId?(checkTenantId(logger$m,e.tenantId),this.tenantId=e.tenantId):this.tenantId="common",this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),checkUnsupportedTenant(this.tenantId)}async prepare(){const e=getPropertyFromVSCode("azure.tenant");e&&(this.tenantId=e),checkUnsupportedTenant(this.tenantId)}prepareOnce(){return this.preparePromise||(this.preparePromise=this.prepare()),this.preparePromise}async getToken(e,t){var n,i;await this.prepareOnce();const r=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$m)||this.tenantId;if(void 0===findCredentials)throw new CredentialUnavailableError(["No implementation of `VisualStudioCodeCredential` is available.","You must install the identity-vscode plugin package (`npm install --save-dev @azure/identity-vscode`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(vsCodePlugin)` before creating a `VisualStudioCodeCredential`.","To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot."].join(" "));let o="string"==typeof e?e:e.join(" ");if(!o.match(/^[0-9a-zA-Z-.:/]+$/)){const t=new Error("Invalid scope was specified by the user or calling client");throw logger$m.getToken.info(formatError(e,t)),t}o.indexOf("offline_access")<0&&(o+=" offline_access");const a=await findCredentials(),{password:s}=null!==(i=null!==(n=a.find((({account:e})=>e===this.cloudName)))&&void 0!==n?n:a[0])&&void 0!==i?i:{};if(s){const t=await this.identityClient.refreshAccessToken(r,AzureAccountClientId,o,s,void 0);if(t)return logger$m.getToken.info(formatSuccess(e)),t.accessToken;{const t=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Have you connected using the 'Azure Account' extension recently? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger$m.getToken.info(formatError(e,t)),t}}{const t=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Did you connect using the 'Azure Account' extension? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger$m.getToken.info(formatError(e,t)),t}}}const pluginContext={cachePluginControl:msalNodeFlowCacheControl,vsCodeCredentialControl:vsCodeCredentialControl};function useIdentityPlugin(e){e(pluginContext)}const msiName$6="ManagedIdentityCredential - AppServiceMSI 2017",logger$l=credentialLogger(msiName$6);function prepareRequestOptions$5(e,t){const n=mapScopesToResource(e);if(!n)throw new Error(`${msiName$6}: Multiple scopes are not supported.`);const i={resource:n,"api-version":"2017-09-01"};t&&(i.clientid=t);const r=new URLSearchParams(i);if(!process.env.MSI_ENDPOINT)throw new Error(`${msiName$6}: Missing environment variable: MSI_ENDPOINT`);if(!process.env.MSI_SECRET)throw new Error(`${msiName$6}: Missing environment variable: MSI_SECRET`);return{url:`${process.env.MSI_ENDPOINT}?${r.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",secret:process.env.MSI_SECRET})}}const appServiceMsi2017={name:"appServiceMsi2017",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger$l.info(`${msiName$6}: Unavailable. Multiple scopes are not supported.`),!1;const t=process.env,n=Boolean(t.MSI_ENDPOINT&&t.MSI_SECRET);return n||logger$l.info(`${msiName$6}: Unavailable. The environment variables needed are: MSI_ENDPOINT and MSI_SECRET.`),n},async getToken(e,t={}){const{identityClient:n,scopes:i,clientId:r,resourceId:o}=e;o&&logger$l.warning(`${msiName$6}: managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger$l.info(`${msiName$6}: Using the endpoint and the secret coming form the environment variables: MSI_ENDPOINT=${process.env.MSI_ENDPOINT} and MSI_SECRET=[REDACTED].`);const a=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions$5(i,r)),{allowInsecureConnection:!0})),s=await n.sendTokenRequest(a);return s&&s.accessToken||null}},msiName$5="ManagedIdentityCredential - CloudShellMSI",logger$k=credentialLogger(msiName$5);function prepareRequestOptions$4(e,t,n){const i=mapScopesToResource(e);if(!i)throw new Error(`${msiName$5}: Multiple scopes are not supported.`);const r={resource:i};if(t&&(r.client_id=t),n&&(r.msi_res_id=n),!process.env.MSI_ENDPOINT)throw new Error(`${msiName$5}: Missing environment variable: MSI_ENDPOINT`);const o=new URLSearchParams(r);return{url:process.env.MSI_ENDPOINT,method:"POST",body:o.toString(),headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",Metadata:"true","Content-Type":"application/x-www-form-urlencoded"})}}const cloudShellMsi={name:"cloudShellMsi",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger$k.info(`${msiName$5}: Unavailable. Multiple scopes are not supported.`),!1;const t=Boolean(process.env.MSI_ENDPOINT);return t||logger$k.info(`${msiName$5}: Unavailable. The environment variable MSI_ENDPOINT is needed.`),t},async getToken(e,t={}){const{identityClient:n,scopes:i,clientId:r,resourceId:o}=e;r&&logger$k.warning(`${msiName$5}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),o&&logger$k.warning(`${msiName$5}: user defined managed Identity by resource Id not supported. The argument resourceId might be ignored by the service.`),logger$k.info(`${msiName$5}: Using the endpoint coming form the environment variable MSI_ENDPOINT = ${process.env.MSI_ENDPOINT}.`);const a=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions$4(i,r,o)),{allowInsecureConnection:!0})),s=await n.sendTokenRequest(a);return s&&s.accessToken||null}},msiName$4="ManagedIdentityCredential - IMDS",logger$j=credentialLogger(msiName$4);function prepareRequestOptions$3(e,t,n,i){var r;const o=mapScopesToResource(e);if(!o)throw new Error(`${msiName$4}: Multiple scopes are not supported.`);const{skipQuery:a,skipMetadataHeader:s}=i||{};let l="";if(!a){const e={resource:o,"api-version":"2018-02-01"};t&&(e.client_id=t),n&&(e.msi_res_id=n);l=`?${new URLSearchParams(e).toString()}`}const c=new URL(imdsEndpointPath,null!==(r=process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)&&void 0!==r?r:imdsHost),d={Accept:"application/json",Metadata:"true"};return s&&delete d.Metadata,{url:`${c}${l}`,method:"GET",headers:coreRestPipeline.createHttpHeaders(d)}}const imdsMsiRetryConfig={maxRetries:3,startDelayInMs:800,intervalIncrement:2},imdsMsi={name:"imdsMsi",async isAvailable({scopes:e,identityClient:t,clientId:n,resourceId:i,getTokenOptions:r={}}){const o=mapScopesToResource(e);if(!o)return logger$j.info(`${msiName$4}: Unavailable. Multiple scopes are not supported.`),!1;if(process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)return!0;if(!t)throw new Error("Missing IdentityClient");const a=prepareRequestOptions$3(o,n,i,{skipMetadataHeader:!0,skipQuery:!0});return tracingClient.withSpan("ManagedIdentityCredential-pingImdsEndpoint",r,(async e=>{var n,i;a.tracingOptions=e.tracingOptions;const r=coreRestPipeline.createPipelineRequest(a);let o;r.timeout=(null===(n=e.requestOptions)||void 0===n?void 0:n.timeout)||1e3,r.allowInsecureConnection=!0;try{logger$j.info(`${msiName$4}: Pinging the Azure IMDS endpoint`),o=await t.sendRequest(r)}catch(e){return coreUtil.isError(e)&&logger$j.verbose(`${msiName$4}: Caught error ${e.name}: ${e.message}`),logger$j.info(`${msiName$4}: The Azure IMDS endpoint is unavailable`),!1}return 403===o.status&&(null===(i=o.bodyAsText)||void 0===i?void 0:i.includes("A socket operation was attempted to an unreachable network"))?(logger$j.info(`${msiName$4}: The Azure IMDS endpoint is unavailable`),logger$j.info(`${msiName$4}: ${o.bodyAsText}`),!1):(logger$j.info(`${msiName$4}: The Azure IMDS endpoint is available`),!0)}))},async getToken(e,t={}){const{identityClient:n,scopes:i,clientId:r,resourceId:o}=e;process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST?logger$j.info(`${msiName$4}: Using the Azure IMDS endpoint coming from the environment variable AZURE_POD_IDENTITY_AUTHORITY_HOST=${process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST}.`):logger$j.info(`${msiName$4}: Using the default Azure IMDS endpoint ${imdsHost}.`);let a=imdsMsiRetryConfig.startDelayInMs;for(let e=0;e<imdsMsiRetryConfig.maxRetries;e++)try{const e=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions$3(i,r,o)),{allowInsecureConnection:!0})),a=await n.sendTokenRequest(e);return a&&a.accessToken||null}catch(e){if(404===e.statusCode){await coreUtil.delay(a),a*=imdsMsiRetryConfig.intervalIncrement;continue}throw e}throw new AuthenticationError(404,`${msiName$4}: Failed to retrieve IMDS token after ${imdsMsiRetryConfig.maxRetries} retries.`)}},msiName$3="ManagedIdentityCredential - Azure Arc MSI",logger$i=credentialLogger(msiName$3);function prepareRequestOptions$2(e,t,n){const i=mapScopesToResource(e);if(!i)throw new Error(`${msiName$3}: Multiple scopes are not supported.`);const r={resource:i,"api-version":"2019-11-01"};if(t&&(r.client_id=t),n&&(r.msi_res_id=n),!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName$3}: Missing environment variable: IDENTITY_ENDPOINT`);const o=new URLSearchParams(r);return coreRestPipeline.createPipelineRequest({url:`${process.env.IDENTITY_ENDPOINT}?${o.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",Metadata:"true"})})}function readFileAsync$1(e,t){return new Promise(((n,i)=>fs.readFile(e,t,((e,t)=>{e&&i(e),n(t)}))))}async function filePathRequest(e,t){const n=await e.sendRequest(coreRestPipeline.createPipelineRequest(t));if(401!==n.status){let e="";throw n.bodyAsText&&(e=` Response: ${n.bodyAsText}`),new AuthenticationError(n.status,`${msiName$3}: To authenticate with Azure Arc MSI, status code 401 is expected on the first request. ${e}`)}const i=n.headers.get("www-authenticate")||"";try{return i.split("=").slice(1)[0]}catch(e){throw Error(`Invalid www-authenticate header format: ${i}`)}}const arcMsi={name:"arc",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger$i.info(`${msiName$3}: Unavailable. Multiple scopes are not supported.`),!1;const t=Boolean(process.env.IMDS_ENDPOINT&&process.env.IDENTITY_ENDPOINT);return t||logger$i.info(`${msiName$3}: The environment variables needed are: IMDS_ENDPOINT and IDENTITY_ENDPOINT`),t},async getToken(e,t={}){var n;const{identityClient:i,scopes:r,clientId:o,resourceId:a}=e;o&&logger$i.warning(`${msiName$3}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),a&&logger$i.warning(`${msiName$3}: user defined managed Identity by resource Id is not supported. Argument resourceId will be ignored.`),logger$i.info(`${msiName$3}: Authenticating.`);const s=Object.assign(Object.assign({disableJsonStringifyOnBody:!0,deserializationMapper:void 0,abortSignal:t.abortSignal},prepareRequestOptions$2(r,o,a)),{allowInsecureConnection:!0}),l=await filePathRequest(i,s);if(!l)throw new Error(`${msiName$3}: Failed to find the token file.`);const c=await readFileAsync$1(l,{encoding:"utf-8"});null===(n=s.headers)||void 0===n||n.set("Authorization",`Basic ${c}`);const d=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({},s),{allowInsecureConnection:!0})),u=await i.sendTokenRequest(d);return u&&u.accessToken||null}};class MsalClientAssertion extends MsalNode{constructor(e){super(e),this.requiresConfidential=!0,this.getAssertion=e.getAssertion}async doGetToken(e,t={}){try{const n=await this.getAssertion(),i=await this.getApp("confidential",t.enableCae).acquireTokenByClientCredential({scopes:e,correlationId:t.correlationId,azureRegion:this.azureRegion,authority:t.authority,claims:t.claims,clientAssertion:n});return this.handleResult(e,this.clientId,i||void 0)}catch(n){let i=n;throw i=null==n?new Error(JSON.stringify(n)):coreUtil.isError(n)?n:new Error(String(n)),this.handleError(e,i,t)}}}const logger$h=credentialLogger("ClientAssertionCredential");class ClientAssertionCredential{constructor(e,t,n,i={}){if(!e||!t||!n)throw new Error("ClientAssertionCredential: tenantId, clientId, and clientAssertion are required parameters.");this.tenantId=e,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==i?void 0:i.additionallyAllowedTenants),this.clientId=t,this.options=i,this.msalFlow=new MsalClientAssertion(Object.assign(Object.assign({},i),{logger:logger$h,clientId:this.clientId,tenantId:this.tenantId,tokenCredentialOptions:this.options,getAssertion:n}))}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$h);const n=Array.isArray(e)?e:[e];return this.msalFlow.getToken(n,t)}))}}const credentialName$3="WorkloadIdentityCredential",SupportedWorkloadEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_FEDERATED_TOKEN_FILE"],logger$g=credentialLogger(credentialName$3);class WorkloadIdentityCredential{constructor(e){this.azureFederatedTokenFileContent=void 0,this.cacheDate=void 0;const t=processEnvVars(SupportedWorkloadEnvironmentVariables).assigned.join(", ");logger$g.info(`Found the following environment variables: ${t}`);const n=null!=e?e:{},i=n.tenantId||process.env.AZURE_TENANT_ID,r=n.clientId||process.env.AZURE_CLIENT_ID;this.federatedTokenFilePath=n.tokenFilePath||process.env.AZURE_FEDERATED_TOKEN_FILE,i&&checkTenantId(logger$g,i),r&&i&&this.federatedTokenFilePath&&(logger$g.info(`Invoking ClientAssertionCredential with tenant ID: ${i}, clientId: ${n.clientId} and federated token path: [REDACTED]`),this.client=new ClientAssertionCredential(i,r,this.readFileContents.bind(this),e))}async getToken(e,t){if(!this.client){const e=`${credentialName$3}: is unavailable. tenantId, clientId, and federatedTokenFilePath are required parameters. \n      In DefaultAzureCredential and ManagedIdentityCredential, these can be provided as environment variables - \n      "AZURE_TENANT_ID",\n      "AZURE_CLIENT_ID",\n      "AZURE_FEDERATED_TOKEN_FILE". See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/workloadidentitycredential/troubleshoot  `;throw logger$g.info(e),new CredentialUnavailableError(e)}return logger$g.info("Invoking getToken() of Client Assertion Credential"),this.client.getToken(e,t)}async readFileContents(){if(void 0!==this.cacheDate&&Date.now()-this.cacheDate>=3e5&&(this.azureFederatedTokenFileContent=void 0),!this.federatedTokenFilePath)throw new CredentialUnavailableError(`${credentialName$3}: is unavailable. Invalid file path provided ${this.federatedTokenFilePath}.`);if(!this.azureFederatedTokenFileContent){const e=(await promises.readFile(this.federatedTokenFilePath,"utf8")).trim();if(!e)throw new CredentialUnavailableError(`${credentialName$3}: is unavailable. No content on the file ${this.federatedTokenFilePath}.`);this.azureFederatedTokenFileContent=e,this.cacheDate=Date.now()}return this.azureFederatedTokenFileContent}}const msiName$2="ManagedIdentityCredential - Token Exchange",logger$f=credentialLogger(msiName$2);function tokenExchangeMsi(){return{name:"tokenExchangeMsi",async isAvailable({clientId:e}){const t=process.env,n=Boolean((e||t.AZURE_CLIENT_ID)&&t.AZURE_TENANT_ID&&process.env.AZURE_FEDERATED_TOKEN_FILE);return n||logger$f.info(`${msiName$2}: Unavailable. The environment variables needed are: AZURE_CLIENT_ID (or the client ID sent through the parameters), AZURE_TENANT_ID and AZURE_FEDERATED_TOKEN_FILE`),n},async getToken(e,t={}){const{scopes:n,clientId:i}=e,r=new WorkloadIdentityCredential(Object.assign(Object.assign({clientId:i,tenantId:process.env.AZURE_TENANT_ID,tokenFilePath:process.env.AZURE_FEDERATED_TOKEN_FILE},{}),{disableInstanceDiscovery:!0}));return await r.getToken(n,t)}}}const msiName$1="ManagedIdentityCredential - Fabric MSI",logger$e=credentialLogger(msiName$1);function prepareRequestOptions$1(e,t,n){const i=mapScopesToResource(e);if(!i)throw new Error(`${msiName$1}: Multiple scopes are not supported.`);const r={resource:i,"api-version":azureFabricVersion};t&&(r.client_id=t),n&&(r.msi_res_id=n);const o=new URLSearchParams(r);if(!process.env.IDENTITY_ENDPOINT)throw new Error("Missing environment variable: IDENTITY_ENDPOINT");if(!process.env.IDENTITY_HEADER)throw new Error("Missing environment variable: IDENTITY_HEADER");return{url:`${process.env.IDENTITY_ENDPOINT}?${o.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json",secret:process.env.IDENTITY_HEADER})}}const fabricMsi={name:"fabricMsi",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger$e.info(`${msiName$1}: Unavailable. Multiple scopes are not supported.`),!1;const t=process.env,n=Boolean(t.IDENTITY_ENDPOINT&&t.IDENTITY_HEADER&&t.IDENTITY_SERVER_THUMBPRINT);return n||logger$e.info(`${msiName$1}: Unavailable. The environment variables needed are: IDENTITY_ENDPOINT, IDENTITY_HEADER and IDENTITY_SERVER_THUMBPRINT`),n},async getToken(e,t={}){const{scopes:n,identityClient:i,clientId:r,resourceId:o}=e;o&&logger$e.warning(`${msiName$1}: user defined managed Identity by resource Id is not supported. Argument resourceId might be ignored by the service.`),logger$e.info([`${msiName$1}:`,"Using the endpoint and the secret coming from the environment variables:",`IDENTITY_ENDPOINT=${process.env.IDENTITY_ENDPOINT},`,"IDENTITY_HEADER=[REDACTED] and","IDENTITY_SERVER_THUMBPRINT=[REDACTED]."].join(" "));const a=coreRestPipeline.createPipelineRequest(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions$1(n,r,o)));a.agent=new https__default.default.Agent({rejectUnauthorized:!1});const s=await i.sendTokenRequest(a);return s&&s.accessToken||null}},msiName="ManagedIdentityCredential - AppServiceMSI 2019",logger$d=credentialLogger(msiName);function prepareRequestOptions(e,t,n){const i=mapScopesToResource(e);if(!i)throw new Error(`${msiName}: Multiple scopes are not supported.`);const r={resource:i,"api-version":"2019-08-01"};t&&(r.client_id=t),n&&(r.mi_res_id=n);const o=new URLSearchParams(r);if(!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: IDENTITY_ENDPOINT`);if(!process.env.IDENTITY_HEADER)throw new Error(`${msiName}: Missing environment variable: IDENTITY_HEADER`);return{url:`${process.env.IDENTITY_ENDPOINT}?${o.toString()}`,method:"GET",headers:coreRestPipeline.createHttpHeaders({Accept:"application/json","X-IDENTITY-HEADER":process.env.IDENTITY_HEADER})}}const appServiceMsi2019={name:"appServiceMsi2019",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger$d.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const t=process.env,n=Boolean(t.IDENTITY_ENDPOINT&&t.IDENTITY_HEADER);return n||logger$d.info(`${msiName}: Unavailable. The environment variables needed are: IDENTITY_ENDPOINT and IDENTITY_HEADER.`),n},async getToken(e,t={}){const{identityClient:n,scopes:i,clientId:r,resourceId:o}=e;logger$d.info(`${msiName}: Using the endpoint and the secret coming form the environment variables: IDENTITY_ENDPOINT=${process.env.IDENTITY_ENDPOINT} and IDENTITY_HEADER=[REDACTED].`);const a=coreRestPipeline.createPipelineRequest(Object.assign(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions(i,r,o)),{allowInsecureConnection:!0})),s=await n.sendTokenRequest(a);return s&&s.accessToken||null}},logger$c=credentialLogger("ManagedIdentityCredential");class ManagedIdentityCredential{constructor(e,t){var n;let i;if(this.isEndpointUnavailable=null,this.isAppTokenProviderInitialized=!1,"string"==typeof e?(this.clientId=e,i=t):(this.clientId=null==e?void 0:e.clientId,i=e),this.resourceId=null==i?void 0:i.resourceId,this.clientId&&this.resourceId)throw new Error(`${ManagedIdentityCredential.name} - Client Id and Resource Id can't be provided at the same time.`);this.identityClient=new IdentityClient(i),this.isAvailableIdentityClient=new IdentityClient(Object.assign(Object.assign({},i),{retryOptions:{maxRetries:0}})),this.confidentialApp=new msalCommon.ConfidentialClientApplication({auth:{authority:"https://login.microsoftonline.com/managed_identity",clientId:null!==(n=this.clientId)&&void 0!==n?n:DeveloperSignOnClientId,clientSecret:"dummy-secret",cloudDiscoveryMetadata:'{"tenant_discovery_endpoint":"https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration","api-version":"1.1","metadata":[{"preferred_network":"login.microsoftonline.com","preferred_cache":"login.windows.net","aliases":["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{"preferred_network":"login.partner.microsoftonline.cn","preferred_cache":"login.partner.microsoftonline.cn","aliases":["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{"preferred_network":"login.microsoftonline.de","preferred_cache":"login.microsoftonline.de","aliases":["login.microsoftonline.de"]},{"preferred_network":"login.microsoftonline.us","preferred_cache":"login.microsoftonline.us","aliases":["login.microsoftonline.us","login.usgovcloudapi.net"]},{"preferred_network":"login-us.microsoftonline.com","preferred_cache":"login-us.microsoftonline.com","aliases":["login-us.microsoftonline.com"]}]}',authorityMetadata:'{"token_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/token","token_endpoint_auth_methods_supported":["client_secret_post","private_key_jwt","client_secret_basic"],"jwks_uri":"https://login.microsoftonline.com/common/discovery/v2.0/keys","response_modes_supported":["query","fragment","form_post"],"subject_types_supported":["pairwise"],"id_token_signing_alg_values_supported":["RS256"],"response_types_supported":["code","id_token","code id_token","id_token token"],"scopes_supported":["openid","profile","email","offline_access"],"issuer":"https://login.microsoftonline.com/{tenantid}/v2.0","request_uri_parameter_supported":false,"userinfo_endpoint":"https://graph.microsoft.com/oidc/userinfo","authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/authorize","device_authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/devicecode","http_logout_supported":true,"frontchannel_logout_supported":true,"end_session_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/logout","claims_supported":["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],"kerberos_endpoint":"https://login.microsoftonline.com/common/kerberos","tenant_region_scope":null,"cloud_instance_name":"microsoftonline.com","cloud_graph_host_name":"graph.windows.net","msgraph_host":"graph.microsoft.com","rbac_url":"https://pas.windows.net"}',clientCapabilities:[]},system:{loggerOptions:{logLevel:getMSALLogLevel(logger$o.getLogLevel())}}})}async cachedAvailableMSI(e,t){if(this.cachedMSI)return this.cachedMSI;const n=[arcMsi,fabricMsi,appServiceMsi2019,appServiceMsi2017,cloudShellMsi,tokenExchangeMsi(),imdsMsi];for(const i of n)if(await i.isAvailable({scopes:e,identityClient:this.isAvailableIdentityClient,clientId:this.clientId,resourceId:this.resourceId,getTokenOptions:t}))return this.cachedMSI=i,i;throw new CredentialUnavailableError(`${ManagedIdentityCredential.name} - No MSI credential available`)}async authenticateManagedIdentity(e,t){const{span:n,updatedOptions:i}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.authenticateManagedIdentity`,t);try{return(await this.cachedAvailableMSI(e,i)).getToken({identityClient:this.identityClient,scopes:e,clientId:this.clientId,resourceId:this.resourceId},i)}catch(e){throw n.setStatus({status:"error",error:e}),e}finally{n.end()}}async getToken(e,t){let n=null;const{span:i,updatedOptions:r}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.getToken`,t);try{if(!0===this.isEndpointUnavailable){const t=new CredentialUnavailableError("The managed identity endpoint is not currently available");throw logger$c.getToken.info(formatError(e,t)),t}if("tokenExchangeMsi"===(await this.cachedAvailableMSI(e,r)).name)n=await this.authenticateManagedIdentity(e,r);else{const i={correlationId:this.identityClient.getCorrelationId(),tenantId:(null==t?void 0:t.tenantId)||"managed_identity",scopes:Array.isArray(e)?e:[e],claims:null==t?void 0:t.claims};this.initializeSetAppTokenProvider();const r=await this.confidentialApp.acquireTokenByClientCredential(Object.assign({},i));n=this.handleResult(e,r||void 0)}if(null===n){this.isEndpointUnavailable=!0;const t=new CredentialUnavailableError("The managed identity endpoint was reached, yet no tokens were received.");throw logger$c.getToken.info(formatError(e,t)),t}this.isEndpointUnavailable=!1;return logger$c.getToken.info(formatSuccess(e)),n}catch(t){if("AuthenticationRequiredError"===t.name)throw t;if(i.setStatus({status:"error",error:t}),"ENETUNREACH"===t.code){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. Network unreachable. Message: ${t.message}`);throw logger$c.getToken.info(formatError(e,n)),n}if("EHOSTUNREACH"===t.code){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. No managed identity endpoint found. Message: ${t.message}`);throw logger$c.getToken.info(formatError(e,n)),n}if(400===t.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: The managed identity endpoint is indicating there's no available identity. Message: ${t.message}`);if((403===t.statusCode||403===t.code)&&t.message.includes("A socket operation was attempted to an unreachable network")){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. Network unreachable. Message: ${t.message}`);throw logger$c.getToken.info(formatError(e,n)),n}if(void 0===t.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Authentication failed. Message ${t.message}`);throw new AuthenticationError(t.statusCode,{error:`${ManagedIdentityCredential.name} authentication failed.`,error_description:t.message})}finally{i.end()}}handleResult(e,t,n){return this.ensureValidMsalToken(e,t,n),logger$c.getToken.info(formatSuccess(e)),{token:t.accessToken,expiresOnTimestamp:t.expiresOn.getTime()}}ensureValidMsalToken(e,t,n){const i=t=>(logger$c.getToken.info(t),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:n,message:t}));if(!t)throw i("No response");if(!t.expiresOn)throw i('Response had no "expiresOn" property.');if(!t.accessToken)throw i('Response had no "accessToken" property.')}initializeSetAppTokenProvider(){this.isAppTokenProviderInitialized||(this.confidentialApp.SetAppTokenProvider((async e=>{logger$c.info(`SetAppTokenProvider invoked with parameters- ${JSON.stringify(e)}`);const t=Object.assign({},e);logger$c.info(`authenticateManagedIdentity invoked with scopes- ${JSON.stringify(e.scopes)} and getTokenOptions - ${JSON.stringify(t)}`);const n=await this.authenticateManagedIdentity(e.scopes,t);if(n){logger$c.info("SetAppTokenProvider will save the token in cache");const e=(null==n?void 0:n.expiresOnTimestamp)?Math.floor((n.expiresOnTimestamp-Date.now())/1e3):0;return{accessToken:null==n?void 0:n.token,expiresInSeconds:e}}return logger$c.info('SetAppTokenProvider token has "no_access_token_returned" as the saved token'),{accessToken:"no_access_token_returned",expiresInSeconds:0}})),this.isAppTokenProviderInitialized=!0)}}function ensureScopes(e){return Array.isArray(e)?e:[e]}function ensureValidScopeForDevTimeCreds(e,t){if(!e.match(/^[0-9a-zA-Z-_.:/]+$/)){const n=new Error("Invalid scope was specified by the user or calling client");throw t.getToken.info(formatError(e,n)),n}}function getScopeResource(e){return e.replace(/\/.default$/,"")}const cliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzureCliAccessToken(e,t,n){let i=[];return t&&(i=["--tenant",t]),new Promise(((t,r)=>{try{child_process__default.default.execFile("az",["account","get-access-token","--output","json","--resource",e,...i],{cwd:cliCredentialInternals.getSafeWorkingDir(),shell:!0,timeout:n},((e,n,i)=>{t({stdout:n,stderr:i,error:e})}))}catch(e){r(e)}}))}},logger$b=credentialLogger("AzureCliCredential");class AzureCliCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger$b,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getToken(e,t={}){const n=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds);n&&checkTenantId(logger$b,n);const i="string"==typeof e?e:e[0];return logger$b.getToken.info(`Using the scope ${i}`),tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async()=>{var t,r,o,a;try{ensureValidScopeForDevTimeCreds(i,logger$b);const s=getScopeResource(i),l=await cliCredentialInternals.getAzureCliAccessToken(s,n,this.timeout),c=null===(t=l.stderr)||void 0===t?void 0:t.match("(.*)az login --scope(.*)"),d=(null===(r=l.stderr)||void 0===r?void 0:r.match("(.*)az login(.*)"))&&!c;if((null===(o=l.stderr)||void 0===o?void 0:o.match("az:(.*)not found"))||(null===(a=l.stderr)||void 0===a?void 0:a.startsWith("'az' is not recognized"))){const t=new CredentialUnavailableError("Azure CLI could not be found. Please visit https://aka.ms/azure-cli for installation instructions and then, once installed, authenticate to your Azure account using 'az login'.");throw logger$b.getToken.info(formatError(e,t)),t}if(d){const t=new CredentialUnavailableError("Please run 'az login' from a command prompt to authenticate before using this credential.");throw logger$b.getToken.info(formatError(e,t)),t}try{const t=l.stdout,n=JSON.parse(t);logger$b.getToken.info(formatSuccess(e));return{token:n.accessToken,expiresOnTimestamp:new Date(n.expiresOn).getTime()}}catch(e){if(l.stderr)throw new CredentialUnavailableError(l.stderr);throw e}}catch(t){const n="CredentialUnavailableError"===t.name?t:new CredentialUnavailableError(t.message||"Unknown error while trying to retrieve the access token");throw logger$b.getToken.info(formatError(e,n)),n}}))}}const processUtils={execFile:(e,t,n)=>new Promise(((i,r)=>{child_process__namespace.execFile(e,t,n,((e,t,n)=>{Buffer.isBuffer(t)&&(t=t.toString("utf8")),Buffer.isBuffer(n)&&(n=n.toString("utf8")),n||e?r(n?new Error(n):e):i(t)}))}))},logger$a=credentialLogger("AzurePowerShellCredential"),isWindows="win32"===process.platform;function formatCommand(e){return isWindows?`${e}.exe`:e}async function runCommands(e,t){const n=[];for(const i of e){const[e,...r]=i,o=await processUtils.execFile(e,r,{encoding:"utf8",timeout:t});n.push(o)}return n}const powerShellErrors={login:"Run Connect-AzAccount to login",installed:"The specified module 'Az.Accounts' with version '2.2.0' was not loaded because no valid module file was found in any module directory"},powerShellPublicErrorMessages={login:"Please run 'Connect-AzAccount' from PowerShell to authenticate before using this credential.",installed:"The 'Az.Account' module >= 2.2.0 is not installed. Install the Azure Az PowerShell module with: \"Install-Module -Name Az -Scope CurrentUser -Repository PSGallery -Force\".",troubleshoot:"To troubleshoot, visit https://aka.ms/azsdk/js/identity/powershellcredential/troubleshoot."},isLoginError=e=>e.message.match(`(.*)${powerShellErrors.login}(.*)`),isNotInstalledError=e=>e.message.match(powerShellErrors.installed),commandStack=[formatCommand("pwsh")];isWindows&&commandStack.push(formatCommand("powershell"));class AzurePowerShellCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger$a,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getAzurePowerShellAccessToken(e,t,n){for(const i of[...commandStack]){try{await runCommands([[i,"/?"]],n)}catch(e){commandStack.shift();continue}let r="";t&&(r=`-TenantId "${t}"`);const o=(await runCommands([[i,"-NoProfile","-NonInteractive","-Command","Import-Module Az.Accounts -MinimumVersion 2.2.0 -PassThru"],[i,"-NoProfile","-NonInteractive","-Command",`Get-AzAccessToken ${r} -ResourceUrl "${e}" | ConvertTo-Json`]]))[1];try{return JSON.parse(o)}catch(e){throw new Error(`Unable to parse the output of PowerShell. Received output: ${o}`)}}throw new Error("Unable to execute PowerShell. Ensure that it is installed in your system")}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async()=>{const n=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds),i="string"==typeof e?e:e[0];n&&checkTenantId(logger$a,n);try{ensureValidScopeForDevTimeCreds(i,logger$a),logger$a.getToken.info(`Using the scope ${i}`);const t=getScopeResource(i),r=await this.getAzurePowerShellAccessToken(t,n,this.timeout);return logger$a.getToken.info(formatSuccess(e)),{token:r.Token,expiresOnTimestamp:new Date(r.ExpiresOn).getTime()}}catch(e){if(isNotInstalledError(e)){const e=new CredentialUnavailableError(powerShellPublicErrorMessages.installed);throw logger$a.getToken.info(formatError(i,e)),e}if(isLoginError(e)){const e=new CredentialUnavailableError(powerShellPublicErrorMessages.login);throw logger$a.getToken.info(formatError(i,e)),e}const t=new CredentialUnavailableError(`${e}. ${powerShellPublicErrorMessages.troubleshoot}`);throw logger$a.getToken.info(formatError(i,t)),t}}))}}const logger$9=credentialLogger("ChainedTokenCredential");class ChainedTokenCredential{constructor(...e){this._sources=[],this._sources=e}async getToken(e,t={}){const{token:n}=await this.getTokenInternal(e,t);return n}async getTokenInternal(e,t={}){let n,i=null;const r=[];return tracingClient.withSpan("ChainedTokenCredential.getToken",t,(async t=>{for(let o=0;o<this._sources.length&&null===i;o++)try{i=await this._sources[o].getToken(e,t),n=this._sources[o]}catch(t){if("CredentialUnavailableError"!==t.name&&"AuthenticationRequiredError"!==t.name)throw logger$9.getToken.info(formatError(e,t)),t;r.push(t)}if(!i&&r.length>0){const t=new AggregateAuthenticationError(r,"ChainedTokenCredential authentication failed.");throw logger$9.getToken.info(formatError(e,t)),t}if(logger$9.getToken.info(`Result for ${n.constructor.name}: ${formatSuccess(e)}`),null===i)throw new CredentialUnavailableError("Failed to retrieve a valid token");return{token:i,successfulCredential:n}}))}}const readFileAsync=util.promisify(fs.readFile);async function parseCertificate(e,t){const n={},i=e.certificate,r=e.certificatePath;n.certificateContents=i||await readFileAsync(r,"utf8"),t&&(n.x5c=n.certificateContents);const o=/(-+BEGIN CERTIFICATE-+)(\n\r?|\r\n?)([A-Za-z0-9+/\n\r]+=*)(\n\r?|\r\n?)(-+END CERTIFICATE-+)/g,a=[];let s;do{s=o.exec(n.certificateContents),s&&a.push(s[3])}while(s);if(0===a.length)throw new Error("The file at the specified path does not contain a PEM-encoded certificate.");return n.thumbprint=crypto.createHash("sha1").update(Buffer.from(a[0],"base64")).digest("hex").toUpperCase(),n}class MsalClientCertificate extends MsalNode{constructor(e){super(e),this.requiresConfidential=!0,this.configuration=e.configuration,this.sendCertificateChain=e.sendCertificateChain}async init(e){try{const e=await parseCertificate(this.configuration,this.sendCertificateChain);let t;if(void 0!==this.configuration.certificatePassword){t=crypto.createPrivateKey({key:e.certificateContents,passphrase:this.configuration.certificatePassword,format:"pem"}).export({format:"pem",type:"pkcs8"}).toString()}else t=e.certificateContents;this.msalConfig.auth.clientCertificate={thumbprint:e.thumbprint,privateKey:t,x5c:e.x5c}}catch(e){throw this.logger.info(formatError("",e)),e}return super.init(e)}async doGetToken(e,t={}){try{const n={scopes:e,correlationId:t.correlationId,azureRegion:this.azureRegion,authority:t.authority,claims:t.claims},i=await this.getApp("confidential",t.enableCae).acquireTokenByClientCredential(n);return this.handleResult(e,this.clientId,i||void 0)}catch(n){throw this.handleError(e,n,t)}}}const credentialName$2="ClientCertificateCredential",logger$8=credentialLogger(credentialName$2);class ClientCertificateCredential{constructor(e,t,n,i={}){if(!e||!t)throw new Error(`${credentialName$2}: tenantId and clientId are required parameters.`);this.tenantId=e,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==i?void 0:i.additionallyAllowedTenants);const r=Object.assign({},"string"==typeof n?{certificatePath:n}:n),o=r.certificate,a=r.certificatePath;if(!r||!o&&!a)throw new Error(`${credentialName$2}: Provide either a PEM certificate in string form, or the path to that certificate in the filesystem. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);if(o&&a)throw new Error(`${credentialName$2}: To avoid unexpected behaviors, providing both the contents of a PEM certificate and the path to a PEM certificate is forbidden. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);this.msalFlow=new MsalClientCertificate(Object.assign(Object.assign({},i),{configuration:r,logger:logger$8,clientId:t,tenantId:e,sendCertificateChain:i.sendCertificateChain,tokenCredentialOptions:i}))}async getToken(e,t={}){return tracingClient.withSpan(`${credentialName$2}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$8);const n=Array.isArray(e)?e:[e];return this.msalFlow.getToken(n,t)}))}}class MsalClientSecret extends MsalNode{constructor(e){super(e),this.requiresConfidential=!0,this.msalConfig.auth.clientSecret=e.clientSecret}async doGetToken(e,t={}){try{const n=await this.getApp("confidential",t.enableCae).acquireTokenByClientCredential({scopes:e,correlationId:t.correlationId,azureRegion:this.azureRegion,authority:t.authority,claims:t.claims});return this.handleResult(e,this.clientId,n||void 0)}catch(n){throw this.handleError(e,n,t)}}}const logger$7=credentialLogger("ClientSecretCredential");class ClientSecretCredential{constructor(e,t,n,i={}){if(!e||!t||!n)throw new Error("ClientSecretCredential: tenantId, clientId, and clientSecret are required parameters. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.");this.tenantId=e,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==i?void 0:i.additionallyAllowedTenants),this.msalFlow=new MsalClientSecret(Object.assign(Object.assign({},i),{logger:logger$7,clientId:t,tenantId:e,clientSecret:n,tokenCredentialOptions:i}))}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$7);const n=ensureScopes(e);return this.msalFlow.getToken(n,t)}))}}class MsalUsernamePassword extends MsalNode{constructor(e){super(e),this.username=e.username,this.password=e.password}async doGetToken(e,t){try{const n={scopes:e,username:this.username,password:this.password,correlationId:null==t?void 0:t.correlationId,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims},i=await this.getApp("public",null==t?void 0:t.enableCae).acquireTokenByUsernamePassword(n);return this.handleResult(e,this.clientId,i||void 0)}catch(n){throw this.handleError(e,n,t)}}}const logger$6=credentialLogger("UsernamePasswordCredential");class UsernamePasswordCredential{constructor(e,t,n,i,r={}){if(!(e&&t&&n&&i))throw new Error("UsernamePasswordCredential: tenantId, clientId, username and password are required parameters. To troubleshoot, visit https://aka.ms/azsdk/js/identity/usernamepasswordcredential/troubleshoot.");this.tenantId=e,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==r?void 0:r.additionallyAllowedTenants),this.msalFlow=new MsalUsernamePassword(Object.assign(Object.assign({},r),{logger:logger$6,clientId:t,tenantId:e,username:n,password:i,tokenCredentialOptions:r||{}}))}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$6);const n=ensureScopes(e);return this.msalFlow.getToken(n,t)}))}}const AllSupportedEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_CLIENT_SECRET","AZURE_CLIENT_CERTIFICATE_PATH","AZURE_CLIENT_CERTIFICATE_PASSWORD","AZURE_USERNAME","AZURE_PASSWORD","AZURE_ADDITIONALLY_ALLOWED_TENANTS"];function getAdditionallyAllowedTenants(){var e;return(null!==(e=process.env.AZURE_ADDITIONALLY_ALLOWED_TENANTS)&&void 0!==e?e:"").split(";")}const credentialName$1="EnvironmentCredential",logger$5=credentialLogger(credentialName$1);class EnvironmentCredential{constructor(e){this._credential=void 0;const t=processEnvVars(AllSupportedEnvironmentVariables).assigned.join(", ");logger$5.info(`Found the following environment variables: ${t}`);const n=process.env.AZURE_TENANT_ID,i=process.env.AZURE_CLIENT_ID,r=process.env.AZURE_CLIENT_SECRET,o=getAdditionallyAllowedTenants(),a=Object.assign(Object.assign({},e),{additionallyAllowedTenantIds:o});if(n&&checkTenantId(logger$5,n),n&&i&&r)return logger$5.info(`Invoking ClientSecretCredential with tenant ID: ${n}, clientId: ${i} and clientSecret: [REDACTED]`),void(this._credential=new ClientSecretCredential(n,i,r,a));const s=process.env.AZURE_CLIENT_CERTIFICATE_PATH,l=process.env.AZURE_CLIENT_CERTIFICATE_PASSWORD;if(n&&i&&s)return logger$5.info(`Invoking ClientCertificateCredential with tenant ID: ${n}, clientId: ${i} and certificatePath: ${s}`),void(this._credential=new ClientCertificateCredential(n,i,{certificatePath:s,certificatePassword:l},a));const c=process.env.AZURE_USERNAME,d=process.env.AZURE_PASSWORD;n&&i&&c&&d&&(logger$5.info(`Invoking UsernamePasswordCredential with tenant ID: ${n}, clientId: ${i} and username: ${c}`),this._credential=new UsernamePasswordCredential(n,i,c,d,a))}async getToken(e,t={}){return tracingClient.withSpan(`${credentialName$1}.getToken`,t,(async t=>{if(this._credential)try{const n=await this._credential.getToken(e,t);return logger$5.getToken.info(formatSuccess(e)),n}catch(t){const n=new AuthenticationError(400,{error:`${credentialName$1} authentication failed. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`,error_description:t.message.toString().split("More details:").join("")});throw logger$5.getToken.info(formatError(e,n)),n}throw new CredentialUnavailableError(`${credentialName$1} is unavailable. No underlying credential could be used. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`)}))}}const developerCliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure Developer CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzdAccessToken(e,t,n){let i=[];return t&&(i=["--tenant-id",t]),new Promise(((t,r)=>{try{child_process__default.default.execFile("azd",["auth","token","--output","json",...e.reduce(((e,t)=>e.concat("--scope",t)),[]),...i],{cwd:developerCliCredentialInternals.getSafeWorkingDir(),timeout:n},((e,n,i)=>{t({stdout:n,stderr:i,error:e})}))}catch(e){r(e)}}))}},logger$4=credentialLogger("AzureDeveloperCliCredential");class AzureDeveloperCliCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger$4,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getToken(e,t={}){const n=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds);let i;return n&&checkTenantId(logger$4,n),i="string"==typeof e?[e]:e,logger$4.getToken.info(`Using the scopes ${e}`),tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async()=>{var t,r,o,a;try{i.forEach((e=>{ensureValidScopeForDevTimeCreds(e,logger$4)}));const s=await developerCliCredentialInternals.getAzdAccessToken(i,n,this.timeout),l=(null===(t=s.stderr)||void 0===t?void 0:t.match("not logged in, run `azd login` to login"))||(null===(r=s.stderr)||void 0===r?void 0:r.match("not logged in, run `azd auth login` to login"));if((null===(o=s.stderr)||void 0===o?void 0:o.match("azd:(.*)not found"))||(null===(a=s.stderr)||void 0===a?void 0:a.startsWith("'azd' is not recognized"))||s.error&&"ENOENT"===s.error.code){const t=new CredentialUnavailableError("Azure Developer CLI couldn't be found. To mitigate this issue, see the troubleshooting guidelines at https://aka.ms/azsdk/js/identity/azdevclicredential/troubleshoot.");throw logger$4.getToken.info(formatError(e,t)),t}if(l){const t=new CredentialUnavailableError("Please run 'azd auth login' from a command prompt to authenticate before using this credential. For more information, see the troubleshooting guidelines at https://aka.ms/azsdk/js/identity/azdevclicredential/troubleshoot.");throw logger$4.getToken.info(formatError(e,t)),t}try{const t=JSON.parse(s.stdout);return logger$4.getToken.info(formatSuccess(e)),{token:t.token,expiresOnTimestamp:new Date(t.expiresOn).getTime()}}catch(e){if(s.stderr)throw new CredentialUnavailableError(s.stderr);throw e}}catch(t){const n="CredentialUnavailableError"===t.name?t:new CredentialUnavailableError(t.message||"Unknown error while trying to retrieve the access token");throw logger$4.getToken.info(formatError(e,n)),n}}))}}class DefaultManagedIdentityCredential extends ManagedIdentityCredential{constructor(e){var t,n,i;const r=null!==(t=null==e?void 0:e.managedIdentityClientId)&&void 0!==t?t:process.env.AZURE_CLIENT_ID,o=null!==(n=null==e?void 0:e.workloadIdentityClientId)&&void 0!==n?n:r,a=null==e?void 0:e.managedIdentityResourceId,s=process.env.AZURE_FEDERATED_TOKEN_FILE,l=null!==(i=null==e?void 0:e.tenantId)&&void 0!==i?i:process.env.AZURE_TENANT_ID;if(a){super(Object.assign(Object.assign({},e),{resourceId:a}))}else if(s&&o){super(o,Object.assign(Object.assign({},e),{tenantId:l}))}else if(r){super(Object.assign(Object.assign({},e),{clientId:r}))}else super(e)}}class DefaultWorkloadIdentityCredential extends WorkloadIdentityCredential{constructor(e){var t,n,i;const r=null!==(t=null==e?void 0:e.managedIdentityClientId)&&void 0!==t?t:process.env.AZURE_CLIENT_ID,o=null!==(n=null==e?void 0:e.workloadIdentityClientId)&&void 0!==n?n:r,a=process.env.AZURE_FEDERATED_TOKEN_FILE,s=null!==(i=null==e?void 0:e.tenantId)&&void 0!==i?i:process.env.AZURE_TENANT_ID;if(a&&o){super(Object.assign(Object.assign({},e),{tenantId:s,clientId:o,tokenFilePath:a}))}else if(s){super(Object.assign(Object.assign({},e),{tenantId:s}))}else super(e)}}class DefaultAzureDeveloperCliCredential extends AzureDeveloperCliCredential{constructor(e){super(Object.assign({processTimeoutInMs:null==e?void 0:e.processTimeoutInMs},e))}}class DefaultAzureCliCredential extends AzureCliCredential{constructor(e){super(Object.assign({processTimeoutInMs:null==e?void 0:e.processTimeoutInMs},e))}}class DefaultAzurePowershellCredential extends AzurePowerShellCredential{constructor(e){super(Object.assign({processTimeoutInMs:null==e?void 0:e.processTimeoutInMs},e))}}const defaultCredentials=[EnvironmentCredential,DefaultWorkloadIdentityCredential,DefaultManagedIdentityCredential,DefaultAzureCliCredential,DefaultAzurePowershellCredential,DefaultAzureDeveloperCliCredential];class DefaultAzureCredential extends ChainedTokenCredential{constructor(e){super(...defaultCredentials.map((t=>new t(e))))}}const interactiveBrowserMockable={open:open__default.default};class MsalOpenBrowser extends MsalNode{constructor(e){super(e),this.logger=credentialLogger("Node.js MSAL Open Browser"),this.redirectUri=e.redirectUri,this.loginHint=e.loginHint;const t=new URL(this.redirectUri);this.port=parseInt(t.port),isNaN(this.port)&&(this.port=80),this.hostname=t.hostname}async acquireTokenByCode(e,t){return this.getApp("public",t).acquireTokenByCode(e)}doGetToken(e,t){return new Promise(((n,i)=>{const r=[],o=http__default.default.createServer(((r,o)=>{var a;if(!r.url)return void i(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'));let s;try{s=new URL(r.url,this.redirectUri)}catch(e){return void i(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}const c={code:s.searchParams.get("code"),redirectUri:this.redirectUri,scopes:e,authority:null==t?void 0:t.authority,codeVerifier:null===(a=this.pkceCodes)||void 0===a?void 0:a.verifier};this.acquireTokenByCode(c,null==t?void 0:t.enableCae).then((t=>{(null==t?void 0:t.account)&&(this.account=msalToPublic(this.clientId,t.account));if(t&&t.expiresOn){const i=null==t?void 0:t.expiresOn.valueOf();o.writeHead(200),o.end("Authentication Complete. You can close the browser and return to the application."),this.logger.getToken.info(formatSuccess(e)),n({expiresOnTimestamp:i,token:t.accessToken})}else{const t=formatError(e,`${s.searchParams.get("error")}. ${s.searchParams.get("error_description")}`);o.writeHead(500),o.end(t),this.logger.getToken.info(t),i(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"'))}l()})).catch((()=>{const t=formatError(e,`${s.searchParams.get("error")}. ${s.searchParams.get("error_description")}`);o.writeHead(500),o.end(t),this.logger.getToken.info(t),i(new Error('Interactive Browser Authentication Error "Did not receive token with a valid expiration"')),l()}))})),a=stoppable__default.default(o),s=o.listen(this.port,this.hostname,(()=>this.logger.info(`InteractiveBrowserCredential listening on port ${this.port}!`)));function l(){s&&s.close();for(const e of r)e.destroy();a&&(a.close(),a.stop())}o.on("connection",(e=>r.push(e))),o.on("error",(e=>{l();const t=e.code;i(new CredentialUnavailableError("EACCES"===t||"EADDRINUSE"===t?[`InteractiveBrowserCredential: Access denied to port ${this.port}.`,"Try sending a redirect URI with a different port, as follows:",'`new InteractiveBrowserCredential({ redirectUri: "http://localhost:1337" })`'].join(" "):`InteractiveBrowserCredential: Failed to start the necessary web server. Error: ${e.message}`))})),o.on("listening",(()=>{const n=this.openAuthCodeUrl(e,t),r=null==t?void 0:t.abortSignal;r&&r.addEventListener("abort",(()=>{l(),i(new Error("Aborted"))})),n.catch((e=>{l(),i(e)}))}))}))}async openAuthCodeUrl(e,t){const n=new msalCommon__namespace.CryptoProvider;this.pkceCodes=await n.generatePkceCodes();const i={scopes:e,correlationId:null==t?void 0:t.correlationId,redirectUri:this.redirectUri,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims,loginHint:this.loginHint,codeChallenge:this.pkceCodes.challenge,codeChallengeMethod:"S256"},r=await this.getApp("public",null==t?void 0:t.enableCae).getAuthCodeUrl(i);try{await interactiveBrowserMockable.open(r,{wait:!0,newInstance:!0})}catch(e){throw new CredentialUnavailableError(`InteractiveBrowserCredential: Could not open a browser window. Error: ${e.message}`)}}}const logger$3=credentialLogger("InteractiveBrowserCredential");class InteractiveBrowserCredential{constructor(e={}){const t="function"==typeof e.redirectUri?e.redirectUri():e.redirectUri||"http://localhost";this.tenantId=null==e?void 0:e.tenantId,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.msalFlow=new MsalOpenBrowser(Object.assign(Object.assign({},e),{tokenCredentialOptions:e,logger:logger$3,redirectUri:t})),this.disableAutomaticAuthentication=null==e?void 0:e.disableAutomaticAuthentication}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$3);const n=ensureScopes(e);return this.msalFlow.getToken(n,Object.assign(Object.assign({},t),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}async authenticate(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.authenticate`,t,(async t=>{const n=ensureScopes(e);return await this.msalFlow.getToken(n,t),this.msalFlow.getActiveAccount()}))}}class MsalDeviceCode extends MsalNode{constructor(e){super(e),this.userPromptCallback=e.userPromptCallback}async doGetToken(e,t){try{const n={deviceCodeCallback:this.userPromptCallback,scopes:e,cancel:!1,correlationId:null==t?void 0:t.correlationId,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims},i=this.getApp("public",null==t?void 0:t.enableCae).acquireTokenByDeviceCode(n),r=await this.withCancellation(i,null==t?void 0:t.abortSignal,(()=>{n.cancel=!0}));return this.handleResult(e,this.clientId,r||void 0)}catch(n){throw this.handleError(e,n,t)}}}const logger$2=credentialLogger("DeviceCodeCredential");function defaultDeviceCodePromptCallback(e){console.log(e.message)}class DeviceCodeCredential{constructor(e){this.tenantId=null==e?void 0:e.tenantId,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.msalFlow=new MsalDeviceCode(Object.assign(Object.assign({},e),{logger:logger$2,userPromptCallback:(null==e?void 0:e.userPromptCallback)||defaultDeviceCodePromptCallback,tokenCredentialOptions:e||{}})),this.disableAutomaticAuthentication=null==e?void 0:e.disableAutomaticAuthentication}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger$2);const n=ensureScopes(e);return this.msalFlow.getToken(n,Object.assign(Object.assign({},t),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}async authenticate(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.authenticate`,t,(async t=>{const n=Array.isArray(e)?e:[e];return await this.msalFlow.getToken(n,t),this.msalFlow.getActiveAccount()}))}}class MsalAuthorizationCode extends MsalNode{constructor(e){super(e),this.logger=credentialLogger("Node.js MSAL Authorization Code"),this.redirectUri=e.redirectUri,this.authorizationCode=e.authorizationCode,e.clientSecret&&(this.msalConfig.auth.clientSecret=e.clientSecret)}async getAuthCodeUrl(e){return await this.init(),this.getApp("confidentialFirst",e.enableCae).getAuthCodeUrl({scopes:e.scopes,redirectUri:e.redirectUri})}async doGetToken(e,t){try{const n=await this.getApp("confidentialFirst",null==t?void 0:t.enableCae).acquireTokenByCode({scopes:e,redirectUri:this.redirectUri,code:this.authorizationCode,correlationId:null==t?void 0:t.correlationId,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims});return this.handleResult(e,this.clientId,n||void 0)}catch(n){throw this.handleError(e,n,t)}}}const logger$1=credentialLogger("AuthorizationCodeCredential");class AuthorizationCodeCredential{constructor(e,t,n,i,r,o){checkTenantId(logger$1,e);let a=n;"string"==typeof r?(this.authorizationCode=i,this.redirectUri=r):(this.authorizationCode=n,this.redirectUri=i,a=void 0,o=r),this.tenantId=e,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==o?void 0:o.additionallyAllowedTenants),this.msalFlow=new MsalAuthorizationCode(Object.assign(Object.assign({},o),{clientSecret:a,clientId:t,tenantId:e,tokenCredentialOptions:o||{},logger:logger$1,redirectUri:this.redirectUri,authorizationCode:this.authorizationCode}))}async getToken(e,t={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async t=>{const n=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds);t.tenantId=n;const i=ensureScopes(e);return this.msalFlow.getToken(i,Object.assign(Object.assign({},t),{disableAutomaticAuthentication:this.disableAutomaticAuthentication}))}))}}class MsalOnBehalfOf extends MsalNode{constructor(e){super(e),this.logger.info("Initialized MSAL's On-Behalf-Of flow"),this.requiresConfidential=!0,this.userAssertionToken=e.userAssertionToken,this.certificatePath=e.certificatePath,this.sendCertificateChain=e.sendCertificateChain,this.clientSecret=e.clientSecret}async init(e){if(this.certificatePath)try{const e=await parseCertificate({certificatePath:this.certificatePath},this.sendCertificateChain);this.msalConfig.auth.clientCertificate={thumbprint:e.thumbprint,privateKey:e.certificateContents,x5c:e.x5c}}catch(e){throw this.logger.info(formatError("",e)),e}else this.msalConfig.auth.clientSecret=this.clientSecret;return super.init(e)}async doGetToken(e,t={}){try{const n=await this.getApp("confidential",t.enableCae).acquireTokenOnBehalfOf({scopes:e,correlationId:t.correlationId,authority:t.authority,claims:t.claims,oboAssertion:this.userAssertionToken});return this.handleResult(e,this.clientId,n||void 0)}catch(n){throw this.handleError(e,n,t)}}}const credentialName="OnBehalfOfCredential",logger=credentialLogger(credentialName);class OnBehalfOfCredential{constructor(e){this.options=e;const{clientSecret:t}=e,{certificatePath:n}=e,{tenantId:i,clientId:r,userAssertionToken:o,additionallyAllowedTenants:a}=e;if(!i||!r||!t&&!n||!o)throw new Error(`${credentialName}: tenantId, clientId, clientSecret (or certificatePath) and userAssertionToken are required parameters.`);this.tenantId=i,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(a),this.msalFlow=new MsalOnBehalfOf(Object.assign(Object.assign({},this.options),{logger:logger,tokenCredentialOptions:this.options}))}async getToken(e,t={}){return tracingClient.withSpan(`${credentialName}.getToken`,t,(async t=>{t.tenantId=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger);const n=ensureScopes(e);return this.msalFlow.getToken(n,t)}))}}function getDefaultAzureCredential(){return new DefaultAzureCredential}exports.AggregateAuthenticationError=AggregateAuthenticationError,exports.AggregateAuthenticationErrorName="AggregateAuthenticationError",exports.AuthenticationError=AuthenticationError,exports.AuthenticationErrorName="AuthenticationError",exports.AuthenticationRequiredError=AuthenticationRequiredError,exports.AuthorizationCodeCredential=AuthorizationCodeCredential,exports.AzureCliCredential=AzureCliCredential,exports.AzureDeveloperCliCredential=AzureDeveloperCliCredential,exports.AzurePowerShellCredential=AzurePowerShellCredential,exports.ChainedTokenCredential=ChainedTokenCredential,exports.ClientAssertionCredential=ClientAssertionCredential,exports.ClientCertificateCredential=ClientCertificateCredential,exports.ClientSecretCredential=ClientSecretCredential,exports.CredentialUnavailableError=CredentialUnavailableError,exports.CredentialUnavailableErrorName="CredentialUnavailableError",exports.DefaultAzureCredential=DefaultAzureCredential,exports.DeviceCodeCredential=DeviceCodeCredential,exports.EnvironmentCredential=EnvironmentCredential,exports.InteractiveBrowserCredential=InteractiveBrowserCredential,exports.ManagedIdentityCredential=ManagedIdentityCredential,exports.OnBehalfOfCredential=OnBehalfOfCredential,exports.UsernamePasswordCredential=UsernamePasswordCredential,exports.VisualStudioCodeCredential=VisualStudioCodeCredential,exports.WorkloadIdentityCredential=WorkloadIdentityCredential,exports.deserializeAuthenticationRecord=deserializeAuthenticationRecord,exports.getDefaultAzureCredential=getDefaultAzureCredential,exports.logger=logger$n,exports.serializeAuthenticationRecord=serializeAuthenticationRecord,exports.useIdentityPlugin=useIdentityPlugin;