var assert=require("assert"),ASN1=require("./types"),errors=require("./errors"),InvalidAsn1Error=errors.InvalidAsn1Error;function Reader(t){if(!t||!Buffer.isBuffer(t))throw new TypeError("data must be a node Buffer");this._buf=t,this._size=t.length,this._len=0,this._offset=0}Object.defineProperty(Reader.prototype,"length",{enumerable:!0,get:function(){return this._len}}),Object.defineProperty(Reader.prototype,"offset",{enumerable:!0,get:function(){return this._offset}}),Object.defineProperty(Reader.prototype,"remain",{get:function(){return this._size-this._offset}}),Object.defineProperty(Reader.prototype,"buffer",{get:function(){return this._buf.slice(this._offset)}}),Reader.prototype.readByte=function(t){if(this._size-this._offset<1)return null;var e=255&this._buf[this._offset];return t||(this._offset+=1),e},Reader.prototype.peek=function(){return this.readByte(!0)},Reader.prototype.readLength=function(t){if(void 0===t&&(t=this._offset),t>=this._size)return null;var e=255&this._buf[t++];if(null===e)return null;if(128==(128&e)){if(0==(e&=127))throw InvalidAsn1Error("Indefinite length not supported");if(this._size-t<e)return null;this._len=0;for(var r=0;r<e;r++)this._len*=256,this._len+=255&this._buf[t++]}else this._len=e;return t},Reader.prototype.readSequence=function(t){var e=this.peek();if(null===e)return null;if(void 0!==t&&t!==e)throw InvalidAsn1Error("Expected 0x"+t.toString(16)+": got 0x"+e.toString(16));var r=this.readLength(this._offset+1);return null===r?null:(this._offset=r,e)},Reader.prototype.readInt=function(t){return this._readTag(t)},Reader.prototype.readBoolean=function(t){return"number"!=typeof t&&(t=ASN1.Boolean),0!==this._readTag(t)},Reader.prototype.readEnumeration=function(t){return"number"!=typeof t&&(t=ASN1.Enumeration),this._readTag(t)},Reader.prototype.readString=function(t,e){t||(t=ASN1.OctetString);var r=this.peek();if(null===r)return null;if(r!==t)throw InvalidAsn1Error("Expected 0x"+t.toString(16)+": got 0x"+r.toString(16));var n=this.readLength(this._offset+1);if(null===n)return null;if(this.length>this._size-n)return null;if(this._offset=n,0===this.length)return e?Buffer.alloc(0):"";var i=this._buf.slice(this._offset,this._offset+this.length);return this._offset+=this.length,e?i:i.toString("utf8")},Reader.prototype.readOID=function(t){t||(t=ASN1.OID);var e=this.readString(t,!0);if(null===e)return null;for(var r=[],n=0,i=0;i<e.length;i++){var s=255&e[i];n<<=7,n+=127&s,0==(128&s)&&(r.push(n>>>0),n=0)}return n=r.shift(),r.unshift(n%40),r.unshift(n/40>>0),r.join(".")},Reader.prototype.readBitString=function(t){t||(t=ASN1.BitString);var e=this.peek();if(null===e)return null;if(e!==t)throw InvalidAsn1Error("Expected 0x"+t.toString(16)+": got 0x"+e.toString(16));var r=this.readLength(this._offset+1);if(null===r)return null;if(this.length>this._size-r)return null;if(this._offset=r,0===this.length)return"";var n=this._buf[this._offset++],i=this._buf.slice(this._offset,this._offset+this.length-1),s=parseInt(i.toString("hex"),16).toString(2).padStart(8*i.length,"0");return this._offset+=this.length-1,s.substring(0,s.length-n)},Reader.prototype._readTag=function(t){var e=this.peek();if(null===e)return null;if(void 0!==t&&e!==t)throw InvalidAsn1Error("Expected 0x"+t.toString(16)+": got 0x"+e.toString(16));var r=this.readLength(this._offset+1);if(null===r)return null;if(0===this.length)throw InvalidAsn1Error("Zero-length integer");if(this.length>this._size-r)return null;this._offset=r;for(var n=this._buf.readInt8(this._offset++),i=1;i<this.length;i++)n*=256,n+=this._buf[this._offset++];if(!Number.isSafeInteger(n))throw InvalidAsn1Error("Integer not representable as javascript number");return n},module.exports=Reader;