"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const utils_1=require("./utils"),DEFAULT_SMARTBUFFER_SIZE=4096,DEFAULT_SMARTBUFFER_ENCODING="utf8";class SmartBuffer{constructor(t){if(this.length=0,this._encoding="utf8",this._writeOffset=0,this._readOffset=0,SmartBuffer.isSmartBufferOptions(t))if(t.encoding&&(utils_1.checkEncoding(t.encoding),this._encoding=t.encoding),t.size){if(!(utils_1.isFiniteInteger(t.size)&&t.size>0))throw new Error(utils_1.ERRORS.INVALID_SMARTBUFFER_SIZE);this._buff=Buffer.allocUnsafe(t.size)}else if(t.buff){if(!Buffer.isBuffer(t.buff))throw new Error(utils_1.ERRORS.INVALID_SMARTBUFFER_BUFFER);this._buff=t.buff,this.length=t.buff.length}else this._buff=Buffer.allocUnsafe(4096);else{if(void 0!==t)throw new Error(utils_1.ERRORS.INVALID_SMARTBUFFER_OBJECT);this._buff=Buffer.allocUnsafe(4096)}}static fromSize(t,e){return new this({size:t,encoding:e})}static fromBuffer(t,e){return new this({buff:t,encoding:e})}static fromOptions(t){return new this(t)}static isSmartBufferOptions(t){const e=t;return e&&(void 0!==e.encoding||void 0!==e.size||void 0!==e.buff)}readInt8(t){return this._readNumberValue(Buffer.prototype.readInt8,1,t)}readInt16BE(t){return this._readNumberValue(Buffer.prototype.readInt16BE,2,t)}readInt16LE(t){return this._readNumberValue(Buffer.prototype.readInt16LE,2,t)}readInt32BE(t){return this._readNumberValue(Buffer.prototype.readInt32BE,4,t)}readInt32LE(t){return this._readNumberValue(Buffer.prototype.readInt32LE,4,t)}readBigInt64BE(t){return utils_1.bigIntAndBufferInt64Check("readBigInt64BE"),this._readNumberValue(Buffer.prototype.readBigInt64BE,8,t)}readBigInt64LE(t){return utils_1.bigIntAndBufferInt64Check("readBigInt64LE"),this._readNumberValue(Buffer.prototype.readBigInt64LE,8,t)}writeInt8(t,e){return this._writeNumberValue(Buffer.prototype.writeInt8,1,t,e),this}insertInt8(t,e){return this._insertNumberValue(Buffer.prototype.writeInt8,1,t,e)}writeInt16BE(t,e){return this._writeNumberValue(Buffer.prototype.writeInt16BE,2,t,e)}insertInt16BE(t,e){return this._insertNumberValue(Buffer.prototype.writeInt16BE,2,t,e)}writeInt16LE(t,e){return this._writeNumberValue(Buffer.prototype.writeInt16LE,2,t,e)}insertInt16LE(t,e){return this._insertNumberValue(Buffer.prototype.writeInt16LE,2,t,e)}writeInt32BE(t,e){return this._writeNumberValue(Buffer.prototype.writeInt32BE,4,t,e)}insertInt32BE(t,e){return this._insertNumberValue(Buffer.prototype.writeInt32BE,4,t,e)}writeInt32LE(t,e){return this._writeNumberValue(Buffer.prototype.writeInt32LE,4,t,e)}insertInt32LE(t,e){return this._insertNumberValue(Buffer.prototype.writeInt32LE,4,t,e)}writeBigInt64BE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigInt64BE"),this._writeNumberValue(Buffer.prototype.writeBigInt64BE,8,t,e)}insertBigInt64BE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigInt64BE"),this._insertNumberValue(Buffer.prototype.writeBigInt64BE,8,t,e)}writeBigInt64LE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigInt64LE"),this._writeNumberValue(Buffer.prototype.writeBigInt64LE,8,t,e)}insertBigInt64LE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigInt64LE"),this._insertNumberValue(Buffer.prototype.writeBigInt64LE,8,t,e)}readUInt8(t){return this._readNumberValue(Buffer.prototype.readUInt8,1,t)}readUInt16BE(t){return this._readNumberValue(Buffer.prototype.readUInt16BE,2,t)}readUInt16LE(t){return this._readNumberValue(Buffer.prototype.readUInt16LE,2,t)}readUInt32BE(t){return this._readNumberValue(Buffer.prototype.readUInt32BE,4,t)}readUInt32LE(t){return this._readNumberValue(Buffer.prototype.readUInt32LE,4,t)}readBigUInt64BE(t){return utils_1.bigIntAndBufferInt64Check("readBigUInt64BE"),this._readNumberValue(Buffer.prototype.readBigUInt64BE,8,t)}readBigUInt64LE(t){return utils_1.bigIntAndBufferInt64Check("readBigUInt64LE"),this._readNumberValue(Buffer.prototype.readBigUInt64LE,8,t)}writeUInt8(t,e){return this._writeNumberValue(Buffer.prototype.writeUInt8,1,t,e)}insertUInt8(t,e){return this._insertNumberValue(Buffer.prototype.writeUInt8,1,t,e)}writeUInt16BE(t,e){return this._writeNumberValue(Buffer.prototype.writeUInt16BE,2,t,e)}insertUInt16BE(t,e){return this._insertNumberValue(Buffer.prototype.writeUInt16BE,2,t,e)}writeUInt16LE(t,e){return this._writeNumberValue(Buffer.prototype.writeUInt16LE,2,t,e)}insertUInt16LE(t,e){return this._insertNumberValue(Buffer.prototype.writeUInt16LE,2,t,e)}writeUInt32BE(t,e){return this._writeNumberValue(Buffer.prototype.writeUInt32BE,4,t,e)}insertUInt32BE(t,e){return this._insertNumberValue(Buffer.prototype.writeUInt32BE,4,t,e)}writeUInt32LE(t,e){return this._writeNumberValue(Buffer.prototype.writeUInt32LE,4,t,e)}insertUInt32LE(t,e){return this._insertNumberValue(Buffer.prototype.writeUInt32LE,4,t,e)}writeBigUInt64BE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigUInt64BE"),this._writeNumberValue(Buffer.prototype.writeBigUInt64BE,8,t,e)}insertBigUInt64BE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigUInt64BE"),this._insertNumberValue(Buffer.prototype.writeBigUInt64BE,8,t,e)}writeBigUInt64LE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigUInt64LE"),this._writeNumberValue(Buffer.prototype.writeBigUInt64LE,8,t,e)}insertBigUInt64LE(t,e){return utils_1.bigIntAndBufferInt64Check("writeBigUInt64LE"),this._insertNumberValue(Buffer.prototype.writeBigUInt64LE,8,t,e)}readFloatBE(t){return this._readNumberValue(Buffer.prototype.readFloatBE,4,t)}readFloatLE(t){return this._readNumberValue(Buffer.prototype.readFloatLE,4,t)}writeFloatBE(t,e){return this._writeNumberValue(Buffer.prototype.writeFloatBE,4,t,e)}insertFloatBE(t,e){return this._insertNumberValue(Buffer.prototype.writeFloatBE,4,t,e)}writeFloatLE(t,e){return this._writeNumberValue(Buffer.prototype.writeFloatLE,4,t,e)}insertFloatLE(t,e){return this._insertNumberValue(Buffer.prototype.writeFloatLE,4,t,e)}readDoubleBE(t){return this._readNumberValue(Buffer.prototype.readDoubleBE,8,t)}readDoubleLE(t){return this._readNumberValue(Buffer.prototype.readDoubleLE,8,t)}writeDoubleBE(t,e){return this._writeNumberValue(Buffer.prototype.writeDoubleBE,8,t,e)}insertDoubleBE(t,e){return this._insertNumberValue(Buffer.prototype.writeDoubleBE,8,t,e)}writeDoubleLE(t,e){return this._writeNumberValue(Buffer.prototype.writeDoubleLE,8,t,e)}insertDoubleLE(t,e){return this._insertNumberValue(Buffer.prototype.writeDoubleLE,8,t,e)}readString(t,e){let r;"number"==typeof t?(utils_1.checkLengthValue(t),r=Math.min(t,this.length-this._readOffset)):(e=t,r=this.length-this._readOffset),void 0!==e&&utils_1.checkEncoding(e);const i=this._buff.slice(this._readOffset,this._readOffset+r).toString(e||this._encoding);return this._readOffset+=r,i}insertString(t,e,r){return utils_1.checkOffsetValue(e),this._handleString(t,!0,e,r)}writeString(t,e,r){return this._handleString(t,!1,e,r)}readStringNT(t){void 0!==t&&utils_1.checkEncoding(t);let e=this.length;for(let t=this._readOffset;t<this.length;t++)if(0===this._buff[t]){e=t;break}const r=this._buff.slice(this._readOffset,e);return this._readOffset=e+1,r.toString(t||this._encoding)}insertStringNT(t,e,r){return utils_1.checkOffsetValue(e),this.insertString(t,e,r),this.insertUInt8(0,e+t.length),this}writeStringNT(t,e,r){return this.writeString(t,e,r),this.writeUInt8(0,"number"==typeof e?e+t.length:this.writeOffset),this}readBuffer(t){void 0!==t&&utils_1.checkLengthValue(t);const e="number"==typeof t?t:this.length,r=Math.min(this.length,this._readOffset+e),i=this._buff.slice(this._readOffset,r);return this._readOffset=r,i}insertBuffer(t,e){return utils_1.checkOffsetValue(e),this._handleBuffer(t,!0,e)}writeBuffer(t,e){return this._handleBuffer(t,!1,e)}readBufferNT(){let t=this.length;for(let e=this._readOffset;e<this.length;e++)if(0===this._buff[e]){t=e;break}const e=this._buff.slice(this._readOffset,t);return this._readOffset=t+1,e}insertBufferNT(t,e){return utils_1.checkOffsetValue(e),this.insertBuffer(t,e),this.insertUInt8(0,e+t.length),this}writeBufferNT(t,e){return void 0!==e&&utils_1.checkOffsetValue(e),this.writeBuffer(t,e),this.writeUInt8(0,"number"==typeof e?e+t.length:this._writeOffset),this}clear(){return this._writeOffset=0,this._readOffset=0,this.length=0,this}remaining(){return this.length-this._readOffset}get readOffset(){return this._readOffset}set readOffset(t){utils_1.checkOffsetValue(t),utils_1.checkTargetOffset(t,this),this._readOffset=t}get writeOffset(){return this._writeOffset}set writeOffset(t){utils_1.checkOffsetValue(t),utils_1.checkTargetOffset(t,this),this._writeOffset=t}get encoding(){return this._encoding}set encoding(t){utils_1.checkEncoding(t),this._encoding=t}get internalBuffer(){return this._buff}toBuffer(){return this._buff.slice(0,this.length)}toString(t){const e="string"==typeof t?t:this._encoding;return utils_1.checkEncoding(e),this._buff.toString(e,0,this.length)}destroy(){return this.clear(),this}_handleString(t,e,r,i){let n=this._writeOffset,u=this._encoding;"number"==typeof r?n=r:"string"==typeof r&&(utils_1.checkEncoding(r),u=r),"string"==typeof i&&(utils_1.checkEncoding(i),u=i);const s=Buffer.byteLength(t,u);return e?this.ensureInsertable(s,n):this._ensureWriteable(s,n),this._buff.write(t,n,s,u),e?this._writeOffset+=s:"number"==typeof r?this._writeOffset=Math.max(this._writeOffset,n+s):this._writeOffset+=s,this}_handleBuffer(t,e,r){const i="number"==typeof r?r:this._writeOffset;return e?this.ensureInsertable(t.length,i):this._ensureWriteable(t.length,i),t.copy(this._buff,i),e?this._writeOffset+=t.length:"number"==typeof r?this._writeOffset=Math.max(this._writeOffset,i+t.length):this._writeOffset+=t.length,this}ensureReadable(t,e){let r=this._readOffset;if(void 0!==e&&(utils_1.checkOffsetValue(e),r=e),r<0||r+t>this.length)throw new Error(utils_1.ERRORS.INVALID_READ_BEYOND_BOUNDS)}ensureInsertable(t,e){utils_1.checkOffsetValue(e),this._ensureCapacity(this.length+t),e<this.length&&this._buff.copy(this._buff,e+t,e,this._buff.length),e+t>this.length?this.length=e+t:this.length+=t}_ensureWriteable(t,e){const r="number"==typeof e?e:this._writeOffset;this._ensureCapacity(r+t),r+t>this.length&&(this.length=r+t)}_ensureCapacity(t){const e=this._buff.length;if(t>e){let r=this._buff,i=3*e/2+1;i<t&&(i=t),this._buff=Buffer.allocUnsafe(i),r.copy(this._buff,0,0,e)}}_readNumberValue(t,e,r){this.ensureReadable(e,r);const i=t.call(this._buff,"number"==typeof r?r:this._readOffset);return void 0===r&&(this._readOffset+=e),i}_insertNumberValue(t,e,r,i){return utils_1.checkOffsetValue(i),this.ensureInsertable(e,i),t.call(this._buff,r,i),this._writeOffset+=e,this}_writeNumberValue(t,e,r,i){if("number"==typeof i){if(i<0)throw new Error(utils_1.ERRORS.INVALID_WRITE_BEYOND_BOUNDS);utils_1.checkOffsetValue(i)}const n="number"==typeof i?i:this._writeOffset;return this._ensureWriteable(e,n),t.call(this._buff,r,n),"number"==typeof i?this._writeOffset=Math.max(this._writeOffset,n+e):this._writeOffset+=e,this}}exports.SmartBuffer=SmartBuffer;